/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"


MYSQL * _mysql_query(char * query, int query_len, MYSQL * mysql, char * mysql_host, char *mysql_user,
		char * mysql_passwd, char * dbname)
{
	int err;

	if( mysql_real_query(mysql, query, query_len) != 0)
	{
		err = mysql_errno(mysql);
		if (mysql!=NULL){printf("Query Error %u (%s)\n",err,mysql_error(mysql));}
                if ( err==2006 || err==2013 || err==1053)
                {
                	printf("Try reconnecting, to mysql and retry!\n");
                        sleep(4);
                        if( (mysql=mysql_real_connect(mysql,mysql_host,mysql_user,mysql_passwd,dbname,0,NULL,0)) == NULL)
                        {
                                printf("In evolve_mode, mysql_real_connect returned an error!\n");
                                return NULL;
                        }
			if( mysql_real_query(mysql, query, query_len) != 0)
				return NULL;
		}
		else
			return NULL;
	}

	return mysql;
}
