/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

int delete_all_hits_and_crashes(MYSQL * mysql, char * mysql_host, char * mysql_user, char * mysql_passwd, char * dbname,
	u_int gpf_id, int generation, struct pools * pools, int display_level, int stalk_type)
{
	struct pool * pool;
	struct session * session;
	MYSQL_RES * result;
	char query[1024];
	int query_len = 0;
	int x=0;


        if( display_level==MED || display_level==HIGH)
                printf("Deleting all previous hits for this ID=%d ... ", gpf_id);
        sprintf(query, "DELETE FROM hits WHERE gpf_id='%d'", gpf_id);
        query_len = strlen(query);
        if( mysql_real_query(mysql, query, query_len) != 0)
        {
                printf("In save, mysql_real_query (4) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        if( display_level==MED || display_level==HIGH)
                printf("done.\n");


        if( display_level==MED || display_level==HIGH)
                printf("Deleting all previous crashes for this ID=%d ... ", gpf_id);
        sprintf(query, "DELETE FROM crash WHERE gpf_id='%d'", gpf_id);
        query_len = strlen(query);
        if( mysql_real_query(mysql, query, query_len) != 0)
        {
                printf("In save, mysql_real_query (4) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        if( display_level==MED || display_level==HIGH)
                printf("done.\n");

	return OK;
}

int delete_hits_and_crashes(MYSQL * mysql, char * mysql_host, char * mysql_user, char * mysql_passwd, char * dbname,
	u_int gpf_id, int generation, struct pools * pools, int display_level, int stalk_type)
{
	struct pool * pool;
	struct session * session;
	MYSQL_RES * result;
	char query[1024];
	int query_len = 0;
	int x=0;


	sprintf(query, "SELECT eip FROM hits WHERE gpf_id='%d' AND generation='%d'", gpf_id, generation);
        query_len = strlen(query);
        if( mysql_real_query(mysql, query, query_len) != 0)
        {
                printf("In save, mysql_real_query (0) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        if( (result = mysql_store_result(mysql)) == NULL)
        {
                printf("In save, mysql_store_result (0) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        x = mysql_num_rows(result);
        if( x == 0)
        {
                if( display_level==MED || display_level==HIGH)
                        printf("No previous hits, so no deletion is required.\n");
        }
        else
        {
                if( display_level==MED || display_level==HIGH)
                        printf("Deleting all previous hits for this ID=%d and generation=%d ... ", gpf_id, generation);

                sprintf(query, "DELETE FROM hits WHERE gpf_id='%d' AND generation='%d'", gpf_id, generation);
                query_len = strlen(query);
                if( mysql_real_query(mysql, query, query_len) != 0)
                {
                        printf("In save, mysql_real_query (4) returned an error.\n");
                        if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                        return ERROR;
                }
                if( display_level==MED || display_level==HIGH)
                        printf("done.\n");
        }
        mysql_free_result(result);

	sprintf(query, "SELECT exception_address FROM crash WHERE gpf_id='%d' AND generation='%d'", gpf_id, generation);
        query_len = strlen(query);
        if( mysql_real_query(mysql, query, query_len) != 0)
        {
                printf("In save, mysql_real_query (0) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        if( (result = mysql_store_result(mysql)) == NULL)
        {
                printf("In save, mysql_store_result (0) returned an error.\n");
                if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                return ERROR;
        }
        x = mysql_num_rows(result);
        if( x == 0)
        {
                if( display_level==MED || display_level==HIGH)
                        printf("No previous crashes, so no deletion is required.\n");
        }
        else
        {
                if( display_level==MED || display_level==HIGH)
                        printf("Deleting all previous crashes for this ID=%d and generation=%d ... ", gpf_id, generation);

                sprintf(query, "DELETE FROM crash WHERE gpf_id='%d' AND generation='%d'", gpf_id, generation);
                query_len = strlen(query);
                if( mysql_real_query(mysql, query, query_len) != 0)
                {
                        printf("In save, mysql_real_query (4) returned an error.\n");
                        if (mysql != NULL) { printf("Error %u (%s)\n", mysql_errno(mysql), mysql_error(mysql)); }
                        return ERROR;
                }
                if( display_level==MED || display_level==HIGH)
                        printf("done.\n");
        }
        mysql_free_result(result);

	return OK;
}
