/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

struct seed * read_in_seeds(struct seed * seeds, char * filename)
{
	/*local vars*/	
	int fp_src;
	int fsize=0;
	int x=0;
	int y=0;
	int i, j;
	int block=256;
	char blockptr[block];
	char * file_data=NULL;
	char * ptr=NULL;

	/*open files with error check*/
        umask(0);
        if( (fp_src = open(filename, O_RDONLY, 0666)) <0) {
                TIME(); fprintf(stderr, "{{{Couldn't open src_file.}}}\n"); return NULL; }

	/*read data into array*/
	while ( (x=read(fp_src, blockptr, block)) >0 )
	{
		if(x>0)
			fsize=fsize+x;
		file_data=realloc(file_data, fsize);
		memcpy(file_data+y, blockptr, x);
		if(x>0)
			y=y+x;
	}
	if(fsize == 0){
		TIME(); fprintf(stderr, "{{{NULL FILE - txt_readin}}}\n"); return NULL;}

	/*parse data and store in seeds struct*/
	ptr=file_data;
	i=0;
	while ( 1 )	
	{
		if( (ptr=strstr(ptr, "Type:")) !=NULL )
		{
			seeds = create_next_seed(seeds, i);
			//make it a proper string, by replacing ' ' with \x00
			j=6;
			while(1)
			{
				if ( *(ptr+j)==' ')
				{
					*(ptr+j) = 0x00;
					break;
				}
				j++;
			}

				if( (seeds->type = typestr_to_num(ptr+5)) == ERROR)
				{
					printf("In reads_in_seeds, error 1\n");
					return NULL;
				}

				if( (ptr=strstr(ptr+j+1, "Size:")) == NULL)
				{
					printf("In reads_in_seeds, error 2\n");
					return NULL;
				}
				seeds->data_len = atoi(ptr+5);	
				if( (ptr=strstr(ptr, "Data:")) == NULL)
				{
					printf("In reads_in_seeds, error 3\n");
					return NULL;
				}
				seeds->data=_malloc(seeds->data_len);
               			memcpy(seeds->data, ptr+5, seeds->data_len);
				ptr=ptr+5+seeds->data_len;
		}
		else
			break;
		i++;
	}

	/*close file descriptor*/
        if( (close(fp_src) < 0)) {
                perror("close fp_src"); return NULL; }

	/*find first seed to return the head*/
	while (seeds->prev != NULL)
		seeds = seeds->prev;
	seeds->total_seeds = i;

	return seeds;
}
