/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//-1=error. 0=ok.
int Fuzz_ASCII_SPACE(struct Tok * tok)
{
        u_int r=0;
        u_int i=0;

        if( tok->dataLen==0 ) //used to error, but made null ptr safe
	{
		tok->data=NULL;
		tok->data=_malloc(1);
		tok->data[0]=' ';	
	}

	//assuming it's just one space
	if( tok->dataLen == 1)
	{
		r=_rand(100);
		//20% null
		if ( r < 20)
			tok->data[0]='\x00';
		//20% \r
		else if ( r < 40)
			tok->data[0]='\r';
		//20% \n
		else if ( r < 60)
			tok->data[0]='\n';
		//20% \r\n
		else if ( r < 80)
		{
			if( tok->data == NULL )
			{
				if( (tok->data=_malloc(2)) == NULL )
				{
					TIME(); fprintf(stderr, "{{(1) _malloc in Fuzz_ASCII_SPACE failed!}}\n"); return (-1);
				}
			}
			else
			{
				if( (tok->data=realloc(tok->data, 2)) == NULL )
				{
					TIME(); fprintf(stderr, "{{(1) realloc in Fuzz_ASCII_SPACE failed!}}\n"); return (-1);
				}
			}
			tok->data[0]='\r';
			tok->data[1]='\n';
		}
		//20% delete space
		else if ( r < 100)
		{
			free(tok->data);
			tok->data=NULL;
			tok->dataLen=0;
		}
	}
	//it must be bigger. fill with random junk
	else
	{
		if( tok->data == NULL )
		{
			if( (tok->data=_malloc(tok->dataLen)) == NULL )
			{
				TIME(); fprintf(stderr, "{{(2) _malloc in Fuzz_ASCII_SPACE failed!}}\n"); return (-1);
			}
		}
		for(i=0;i<(tok->dataLen);i++)
			tok->data[i]=_rand(256);
	}

        return 0;
}
