/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//-1=error. 0=ok.
int Fuzz_BitFlip(struct Tok * tok)
{
        u_int i, r;
        u_int num;

        if( tok->dataLen==0 ) //used to error out, but make null ptr safe
	{
		tok->data=NULL;
		if( _rand(100) <50)
			return 0;
		tok->dataLen=_rand(10)+1;
		tok->data=_malloc(tok->dataLen);
	}
        //randomly pick a mode
        //we either want to flip just a couple bits of one byte
        if( (r=_rand(100)) < 40)
        {
                num=tok->dataLen;
                tok->data[_rand(num)]=tok->data[_rand(num)] & (_rand(256));
        }
        //or randomly replace a couple bytes
        else if( r < 80)
        {
                num=_rand(2)+1;
                for(i=0;i<num;i++)
                        tok->data[_rand(tok->dataLen)]=_rand(256);
        }
        //or randomly replacy (rand(dataLen)) bytes
        else
        {
                num=_rand(tok->dataLen);
                for(i=0;i<num;i++)
                        tok->data[_rand(tok->dataLen)]=_rand(256);
        }
        return 0;
}
