/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//-1=error. 0=ok.
int Fuzz_Buffer(struct Tok * tok)
{
        u_int i, r;
        char * half2;
        u_int position, attackSize;
        u_char c;

        if( tok->dataLen==0 ) //used to error out, but make null ptr safe
		tok->data=NULL;

        //randomly pick a position to insert buffer attack
        position=_rand(tok->dataLen+1);
        //configure to half
        if( (half2=_malloc((tok->dataLen)-position)) == NULL)
	{
		printf("In Fuzz_Buffer, _malloc returned an error!\n");
		return ERROR;
	}
        memcpy(half2, (tok->data)+position, (tok->dataLen)-position);

        //randomly pick an attackSize
        if( (r=_rand(100)) < 40)
                attackSize=_rand(30);
        else if( r < 70)
                attackSize=_rand(400);
        else if( r < 90)
                attackSize=_rand(1000);
        else if( r < 97)
                attackSize=_rand(3000);
        else
                attackSize=_rand(100000);
        if( ((tok->data)=realloc((tok->data), ((attackSize)+(tok->dataLen)))) == NULL)
        {
                TIME(); fprintf(stderr, "{{realloc in Fuzz_Buffer failed!}}\n"); return (-1);
        }
        //create and insert attack
        if( (r=_rand(100)) < 15) //all chars
        {
                for(i=0;i<attackSize;i++)
                        *((tok->data)+(i+position))=_rand(256);
                memcpy((tok->data)+position+(attackSize), half2, (tok->dataLen)-position);
        }
        else if (r < 35 )  //ascii only
        {
                for(i=0;i<attackSize;i++)
                        *((tok->data)+(i+position))=_rand(128);
                memcpy((tok->data)+position+(attackSize), half2, (tok->dataLen)-position);
        }
        else if (r < 70) //only alphanumeric
	{
                for(i=0;i<attackSize;i++)
                        *((tok->data)+(i+position))=_rand(96)+32;
                memcpy((tok->data)+position+(attackSize), half2, (tok->dataLen)-position);
        }
        else  //only one char
        {
                c=_rand(96)+32;
                for(i=0;i<attackSize;i++)
                        *((tok->data)+(i+position))=c;
                memcpy((tok->data)+position+(attackSize), half2, (tok->dataLen)-position);
        }
        tok->dataLen=(tok->dataLen)+(attackSize);
        free(half2);
        return 0;
}
