/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//-1=error. 0=ok.
int Fuzz_END(struct Tok * tok)
{
        u_int r=0;
	u_int binary=0;

        if( tok->dataLen==0 ) //used to error, made null ptr safe
	{
		tok->data=NULL;
		if( _rand(100) <50)
                        return 0;
		tok->dataLen=2;
                tok->data=_malloc(tok->dataLen);
		tok->data[0]='\r';
		tok->data[1]='\n';
	}
        if( (tok->data=realloc(tok->data, tok->dataLen+2)) == NULL )
        {
                TIME(); fprintf(stderr, "{{realloc in Fuzz_Str_Ending failed!}}\n"); return (-1);
        }
        //truncate line
        if( tok->data[tok->dataLen-2] == '\r')
                tok->dataLen=tok->dataLen-2;
        else if( tok->data[tok->dataLen-3] == '\r')
                tok->dataLen=tok->dataLen-3;
        else if( tok->data[tok->dataLen-1] == '\n')
                tok->dataLen=tok->dataLen-1;
        else if( tok->data[tok->dataLen-2] == '\n')
                tok->dataLen=tok->dataLen-2;
        else if( tok->data[tok->dataLen-1] == '\x00')
	{
                tok->dataLen=tok->dataLen-1;
		binary=1; //found null as line ending
	}
	else //didn't find ending...oh, we'll add something, probably! :)
	{
	}

  	      //randomize which ending we'll tack-on
 		r=_rand(120);
       		if( r < 20)
       		{
                	memcpy(tok->data+tok->dataLen, "\r\n", 2);
                	tok->dataLen=tok->dataLen+2;
        	}
        	else if( r < 40)
        	{
                	memcpy(tok->data+tok->dataLen, "\n\r", 2);
                	tok->dataLen=tok->dataLen+2;
        	}
        	else if( r < 60)
        	{
                	memcpy(tok->data+tok->dataLen, "\n", 1);
                	tok->dataLen++;
        	}
        	else if( r < 80)
        	{
                	memcpy(tok->data+tok->dataLen, "\r", 1);
                	tok->dataLen++;
        	}
        	else if( r < 100)
        	{
                	memcpy(tok->data+tok->dataLen, "\x00", 1);
                	tok->dataLen++;
        	}
        	//delete line ending, or leave same
        	else
        	{
        	}

        return 0;
}

