/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//-1=error. 0=ok.
int Fuzz_Format(struct Tok * tok)
{
        u_int i=0;
        u_int x=0;
        u_char c=0;
        char * half2=NULL;
        u_int position=0;
        u_int attackSize=0;

        if( tok->dataLen==0 ) //used to error out, but make null ptr safe
                tok->data=NULL;
        //randomly pick a position to insert format attack
        position=_rand(tok->dataLen+1);
        //configure to half
        if( (half2=_malloc((tok->dataLen)-position)) == NULL)
	{
		printf("In Fuzz_Format, _malloc returned an error!\n");
		return ERROR;
	}
        memcpy(half2, (tok->data)+position, (tok->dataLen)-position);

	//randomly pick an attackSize
        attackSize=_rand(20);
        if( ((tok->data)=realloc((tok->data), ((2*attackSize)+(tok->dataLen)))) == NULL)
        {
                TIME(); fprintf(stderr, "{{realloc in Fuzz_Format failed!}}\n"); return (-1);
        }

        //create and insert attack
        if( _rand(100) < 15)
        {
                for(i=0;i<(2*attackSize);i=i+2)
                {
                        *((tok->data)+(i+position))='%';
                        *((tok->data)+(i+1+position))=_rand(128);
                }
                memcpy((tok->data)+position+(2*attackSize), half2, (tok->dataLen)-position);
        }
        else
        {
                if( (x=_rand(100)) < 20)
                        c='s';
                else if( x < 40)
                        c='d';
                else if( x < 60)
                        c='x';
		else
                        c='n';
                for(i=0;i<(2*attackSize);i=i+2)
                {
                        *((tok->data)+(i+position))='%';
                        *((tok->data)+(i+1+position))=c;
                }
                memcpy((tok->data)+position+(2*attackSize), half2, (tok->dataLen)-position);
        }
        tok->dataLen=(tok->dataLen)+(2*attackSize);
        free(half2);
        return 0;
}
