/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//code could be converted to deal with long long int
int Fuzz_Numeric(struct Tok * tok)
{
        u_int i, numLen, fuzzyNumLen, lenDiff, sizeToEnd;
        u_int x=0;
        u_char * numStr=NULL;
        u_char * numEnd=NULL;
        u_char * half2=NULL;
        u_char fuzzyNum[20];
        int num;

	if(tok->dataLen == -1)
	{
		printf("In Fuzz_Numeric, found -1 dataLen\n");
		return ERROR;
	}

	if( tok->dataLen==0 ) //used to error out, but make null ptr safe
        {
                tok->data=NULL;
                if( _rand(100) <50)
                        return 0;
                tok->dataLen=_rand(10)+1;
                tok->data=_malloc(tok->dataLen);
        }

        //cp tok->data into new string we can muck with
        if( (numStr=_malloc(tok->dataLen+1)) == NULL) {
                TIME(); fprintf(stderr, "{{error2 in Fuzz_Numeric}}\n"); return ERROR;
        }
        memcpy(numStr+1, tok->data, tok->dataLen);
        numStr[0]=0x20; //strtoul needs white space at start of string
        //find start of num
        for(i=0; i<(tok->dataLen+1); i++)
        {
                if ( isdigit(numStr[i]) != 0 )
                        break;
        }
        //code to handle the case where no number is found
        if( i == tok->dataLen+1)
        {
                x=_rand(tok->dataLen)+1;
		i=x;
        }
        else //code that deals with a number that was already there
        {
                //back up i if the previous is a +, -, or x (for hex)
                if ( (numStr[i-1] == '+') || (numStr[i-1] == '-') )
                        i--;
                //add one white space if there isn't one before i
                if ( isspace(numStr[i-1]) == 0 )
                        numStr[i-1]=0x20; //for some lame reason strtoul needs this
        }
        if( x == 0)
        {
                //the special base 0, expects 0x for hex, nothing for 10 or second char of 0 for octal
                num=strtol(numStr+i, (char **)&numEnd, 0);
                if( num==LONG_MIN || num==LONG_MAX )
                {
                       printf("In Fuzz_Numeric, odd num. num=%d\n", num);
                }
                //calulate size of current num
                if ( numEnd > (numStr+1+(tok->dataLen)) )
                        numEnd=(numStr+1+(tok->dataLen));
                numLen=(numEnd)-(numStr+i);
        }
        else
        {
                num=_rand(10000)-_rand(10000);
                numLen=0;
                numEnd=(numStr+1)+i;
                i++;
        }
        //make a copy of the data after num
        sizeToEnd=(numEnd)-(numStr+1);
        sizeToEnd=tok->dataLen-sizeToEnd;
        num=Fuzz_Integer(num);
        if( _rand(100) < 70 ) //print as decimal
                sprintf(fuzzyNum, "%d", num);
        else
                sprintf(fuzzyNum, "0x%x", num);
	//get new len and fix tok
        fuzzyNumLen=strlen(fuzzyNum);
        lenDiff=fuzzyNumLen-numLen;
        tok->dataLen+=lenDiff;
        tok->data=realloc(tok->data, tok->dataLen);
        memcpy( (tok->data)+(i-1), fuzzyNum, fuzzyNumLen);
        free(numStr);
        if( sizeToEnd > 0)
        {
                half2=_malloc(sizeToEnd);
                memcpy(half2, numEnd, sizeToEnd);
                memcpy( (tok->data)+(i-1+fuzzyNumLen), half2, sizeToEnd);
                free(half2);
        }

        return OK;
}
