/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//array must be a vaild string
//original is use as a bias toward
//what the parser was (i.e. sometimes it'll be unchanged).
//NULL=error. User strlen for len.
//the string MUST be freed by the user.
u_char * _Fuzz_Parsers(u_char * array, u_char original)
{
        char * out;
        u_int x, y, z, i, arrayLen;
        x=_rand(100);
        y=_rand(100);
        if( array==NULL ) {
                TIME(); fprintf(stderr, "{{error1 in _Fuzz_Parsers}}\n"); return NULL;
        }
        if( (arrayLen=strlen(array)) == 0) {
                TIME(); fprintf(stderr, "{{error2 in _Fuzz_Parsers}}\n"); return NULL;
        }

        if( x < 35) //empty string
        {
                if( (out=_malloc(1+1)) == NULL)
		{
			printf("In _Fuzz_Parsers (1), malloc return an error!\n");
			return NULL;
		}
                if( y < 40)
                {
                        out[0]=0x00;
                }
                else
                {
                        out[0]=original;
                }
                out[1]=0x00;
        }
        else if( x < 70) //one
        {

		if( (out=_malloc(1+1)) == NULL)
		{
			printf("In _Fuzz_Parsers (2), malloc return an error!\n");
			return NULL;
		}
                out[0]=array[_rand(arrayLen)];
                out[1]=0x00;
        }
        else if( x < 83) //1-10, diff or same
        {
                z=_rand(10)+1;
                if( (out=_malloc(z+1)) == NULL)
		{
			printf("In _Fuzz_Parsers (3), malloc return an error!\n");
			return NULL;
		}
                if( y < 65)
                        memset(out, array[_rand(arrayLen)], z);
                else
                {
                        for(i=0; i<z; i++)
                                out[i]=array[_rand(arrayLen)];
                }
                out[z]=0x00;
        }
        else if( x < 96) //1-100, diff or same
        {
                z=_rand(100)+1;
                if( (out=_malloc(z+1)) == NULL)
		{
			printf("In _Fuzz_Parsers (4), malloc return an error!\n");
			return NULL;
		}
                if( y < 65)
                        memset(out, array[_rand(arrayLen)], z);
                else
                {
                        for(i=0; i<z; i++)
                                out[i]=array[_rand(arrayLen)];
                }
                out[z]=0x00;
        }
        else //1-10000, diff or same
        {
                z=_rand(10000)+1;
                if( (out=_malloc(z+1)) == NULL)
		{
			printf("In _Fuzz_Parsers (5), malloc return an error!\n");
			return NULL;
		}
                if( y < 65)
                        memset(out, array[_rand(arrayLen)], z);
                else
                {
                        for(i=0; i<z; i++)
                                out[i]=array[_rand(arrayLen)];
                }
                out[z]=0x00;
        }
        return out;
}

//-1=error. 0=ok.
int Fuzz_Parsers(struct Tok * tok)
{
        int i, x;
        u_char array[]="{}[]()<>\'\"`~!@#$%^&*/\\,.?|=+-_{}[]()<>\'\"";//added a few twice, why??
        u_int parsersNum=0;
        void ** parsersPtr;
        u_char * newPkt=NULL;
        u_char * nextPtr=NULL;
        u_char * prevPtr=NULL;
        u_char * fuzzyPtr=NULL;
        u_char * pkt;
        u_char byte;
        u_int newPktLen=0;
        u_int fuzzyLen=0;

	/*We don't want to mess with any token that's too large*/
	if( tok->dataLen > 40000 )
		return OK;
	
	if( tok->dataLen == -1 )
	{
		printf("In Fuzz_Parsers, found -1 dataLen\n");
		return ERROR;
	}

	if( tok->dataLen==0 ) //used to error out, but make null ptr safe
        {
                tok->data=NULL;
                if( _rand(100) <50)
                        return 0;
                tok->dataLen=_rand(10)+1;
                if( (tok->data=_malloc(tok->dataLen)) == NULL)
		{
			printf("In Fuzz_Parsers (1), malloc return an error!\n");
			return ERROR;
		}
		for(i=0; i<tok->dataLen; i++)
			tok->data[i]=array[_rand(strlen(array))];
        }
        //Find the number of all parsers
        for(i=0; i<tok->dataLen; i++)
                if( (strchr(array, tok->data[i])) !=NULL)
                        parsersNum++;
        //code to handel if no parsers
        if(parsersNum == 0)
        {
                if( (pkt=_malloc(tok->dataLen+2)) == NULL)
		{
			printf("In Fuzz_Parsers (2), malloc return an error!\n");
			return ERROR;
		}
                memcpy(pkt+1, tok->data, tok->dataLen);
                byte=array[_rand(strlen(array))];
                *(pkt)=byte;
                *(pkt+tok->dataLen+1)=byte;
                free(tok->data);
		tok->data=pkt;
                tok->dataLen+=2;

                parsersNum=2;
		if( (parsersPtr=_malloc(4*parsersNum)) == NULL)
		{
			printf("In Fuzz_Parsers (3), malloc return an error!\n");
			return ERROR;
		}
                parsersPtr[0]=tok->data;
                parsersPtr[1]=(tok->data)+tok->dataLen-1;
        }
	else
	{
		if( (parsersPtr=_malloc(4*parsersNum)) == NULL)
		{
			printf("In Fuzz_Parsers (3), malloc return an error!\n");
			return ERROR;
		}
		parsersNum=0;
		//Find the position and number of all parsers
		for(i=0; i<tok->dataLen; i++)
		{
			if( (strchr(array, tok->data[i])) !=NULL)
			{
				parsersPtr[parsersNum]=(tok->data)+i;
				parsersNum++;
			}
		}
	}
        //Fuzz each parser
        prevPtr=tok->data;
        for(i=0; i<parsersNum; i++)
        {
                nextPtr=parsersPtr[i];
                x=nextPtr-prevPtr;
                //make room data
                if(x>0)
                {
                        newPkt=realloc(newPkt, newPktLen+x);
                        //first copy up to parser
                        memcpy(newPkt+newPktLen, prevPtr, x);
                        newPktLen+=x;
                }
                //fuzz
                if( (fuzzyPtr=_Fuzz_Parsers(array, *(nextPtr))) == NULL) {
                        TIME(); fprintf(stderr, "In Fuzz_Parsers, _Fuzz_Parsers returned an error!\n"); return ERROR;
                }
                //get fuzzy len
                fuzzyLen=strlen(fuzzyPtr);
                //make room for fuzzy
                if(fuzzyLen>0)
                {
                        newPkt=realloc(newPkt, newPktLen+fuzzyLen);
                        //cp in new data and start again
                        memcpy(newPkt+newPktLen, fuzzyPtr, fuzzyLen);
                        newPktLen+=fuzzyLen;
                }
                free(fuzzyPtr);
                prevPtr=nextPtr;
                prevPtr++;
        }
        //tack the tail on
        nextPtr=(tok->data)+(tok->dataLen);
        x=nextPtr-prevPtr;
        //make room data
        if(x >0)
        {
                newPkt=realloc(newPkt, newPktLen+x);
                memcpy(newPkt+newPktLen, prevPtr, x);
                newPktLen=newPktLen+x;
        }
        //clean up and reset ptrs
        free(tok->data);
        tok->data=newPkt;
        tok->dataLen=newPktLen;
	free(parsersPtr);
        return 0;
}

