/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

int basic_mode(int argc, char ** argv, char * optarg, int loopedOnce)
{
	/*Variable Definitions*/
        u_short len;
        struct hostent *host_info;      //added for udp
        struct sockaddr_in cliaddr;     //added for udp
        u_char clihost[16];             //added for udp  -- probably won't need except for printing
	int err;
        u_int i, j, k, l, x, y;
	char c;
        u_int loops=0;
        int connfd, listenfd;
        struct addrinfo hints, *res;
        u_int userFunc=1; //0=no user func; 1=yes -- to increasing GPF's speed
        u_int cycleMode=1; //0=close fd after attack; 1=keep replaying if possible
        u_int readWait = 3;
	char * captureFilename=NULL;
        u_char *host, *port, *sport;
        u_int delay=100;
	u_int startLeg=0;
	u_int stopLeg=0;
	u_int currentLeg=0;
	u_int _currentLeg=0;
	u_int tempLeg=0;
	u_int startPosition=0;
	u_int stopPosition=-1;
	u_int _stopPosition=1;
	u_int currentPosition=0;
	u_int _currentPosition=0;
	u_int startSize=0;
	u_int incSize=255;
	u_int stopSize=17000;
	u_int attackSize=0;
	u_int attackChar=0x41;
	u_int extraAttacks=0; //default is one attack (on current line) per cycle
	u_int _extraAttacks=0;
	u_int attacked=0;

	/*were globals*/
	u_int replayMode=0;  //0=client; 1=server
	u_int printChoice=2; //0=ascii; 1=hex; 2=auto
	u_int displayLevel=0; //0=low; 1=med; 2=high
	u_char userFuncName[64];  //holds the name of the userFunc passed from cmdline

	int flags = 0; //used to store fd flags
	int UDP_SERV=0; //Indicates if we're a UDP server or not; 0=no, 1=yes
	int UDP_SERV_READ=0; //Indicates if we've read once with recvfrom to set udpaddr; 0=no, 1=yes
	int TFTP=0; //for tftp hack 0=no need for it, 1=need it, 2=used it;
	int SRCPORT=-1; //created becuase tftp need to know the srcport.  Now allow user to choose.
	struct sockaddr_in udpaddr;  //added for udp

	//It's a bit ugly have these static.
	//Up these if you have a maga huge session to replay
	u_int seq[3000];  //order in which legs took place  0=client speaking; 1=server speaking
	void * Data[1500]; //master list of each of the legs in order
	u_int DataSize[1500];  //used to hold the size of each pkt data
	u_int Count=0;  //total number of client and server legs
	u_int firstTime = 1;
	void * readData[1500];  //used to hold a pointer to the data actually read from target
	u_int readDataSize[1500];  //used to hold the size of each pkt read from target
	ip_address clientIP;
        ip_address serverIP;

        /*prepare the above args into a strange format for the pcap_loop func within, call_readin*/
        void * args[7];
        args[0] = seq;
        args[1] = Data;
        args[2] = DataSize;
        args[3] = &Count;
        args[4] = &firstTime;
        args[5] = &clientIP;
        args[6] = &serverIP;

	/*check number of command line args*/
	if (argc < 23){
		TIME(); fprintf(stderr, "{{{Not enough args}}}\n"); GPF_usage();}
	if ( optarg!=NULL && (strcasecmp("h", optarg))==0 )
		GPF_usage();
	c=*optarg;
	/*handle args*/
	captureFilename = argv[3];
	/*Call the appropriate readin function*/
	if (strstr(captureFilename, ".gpf") != NULL) //.gpf format
		txt_readin(captureFilename, seq, Data, DataSize, &Count);	
	else { //pcap format
		if ( call_readin(captureFilename, (u_char *)args) !=0) {
			TIME(); fprintf(stderr, "{{{Problem reading in capture file! Are you sure this is a pcap file? If it's a .gpf file be sure it has the .gpf extension.}}}\n\n"); exit(-1); }
	}
	/*reserve spaced for the readData*/
	for(x=0; x<Count; x++)
	{
		readData[x]=_malloc(1500);	
		readDataSize[x]=0;	
	}
	/*handle the rest of the args*/
	//0=act as client; 1=act as server
	if( strcasecmp(argv[4], "client") == 0 )
		replayMode = 0;
	else if ( strcasecmp(argv[4], "server") == 0)
		replayMode = 1;
	else{ TIME(); fprintf(stderr, "{{{Bad replayMode.}}}\n\n"); GPF_usage(); }
	host = argv[5];
	port = argv[6];
	sport = argv[7];
	if( strcasecmp(sport, "?") == 0 )
		sport = NULL;
	else
		SRCPORT = atoi(sport);
	bzero(&hints, sizeof(hints));
	if ( strcasecmp(argv[8], "UDP") == 0)
		hints.ai_socktype = SOCK_DGRAM;
	else if ( strcasecmp(argv[8], "TCP") == 0 )
		hints.ai_socktype = SOCK_STREAM;
	else
		GPF_usage();
	srand( (u_int)(atoi(argv[9])) );
	delay = (u_int)(atoi(argv[10]));
	startLeg = (u_int)(atoi(argv[11]));
	if( (strcmp("+", argv[12]))==0)
		stopLeg=Count;
	else
		stopLeg = (u_int)(atoi(argv[12]));
	startPosition = (u_int)(atoi(argv[13]));
	if( (strcmp("+", argv[14]))==0)
		stopPosition=-1;
	else
		stopPosition = (u_int)(atoi(argv[14]));
	startSize = (u_int)(atoi(argv[15]));
	incSize = (u_int)(atoi(argv[16]));
	stopSize = (u_int)(atoi(argv[17]));
	sscanf(argv[18],"%x", &attackChar);
	//none=0; finish=1
	if( strcasecmp(argv[19], "close") == 0 )
		cycleMode = 0;
	else if ( strcasecmp(argv[19], "finish") == 0)
		cycleMode = 1;
	else{ TIME(); fprintf(stderr, "{{{Bad cycleMode.}}}\n\n"); GPF_usage(); }
	if( (extraAttacks = (u_int)(atoi(argv[20]))) < 0)
	{	
		fprintf(stderr, "{{{Bad extraAttacks: needs to be 0 or more}}}\n\n");
		GPF_usage();
	}
	readWait = (u_int)(atoi(argv[21]));
	if( strcasecmp(argv[22], "ascii") == 0 )
		printChoice = TEXT;
	else if ( strcasecmp(argv[22], "hex") == 0)
		printChoice = HEX;
	else if ( strcasecmp(argv[22], "auto") == 0)
		printChoice = AUTO;
	else{ TIME(); fprintf(stderr, "{{{Bad printChoice.}}}\n\n"); GPF_usage(); }
	if( (strcasecmp("none", argv[23]))==0)
		userFunc=0;
	else
		strncpy(userFuncName, argv[23], 60);
	/*Prepare Networking info*/
	if( (err = getaddrinfo(host, port, &hints, &res)) !=0) {
		TIME(); fprintf(stderr, "{{{%s}}}\n", gai_strerror(err)); exit(-1); }
	/*Bind to server IP for TCP */
	if( replayMode == 1 && hints.ai_socktype == SOCK_STREAM)
	{
		if( (listenfd = setup_server(res)) == ERROR) {
			TIME(); fprintf(stderr, "{{{Setup_server failed}}}\n\n"); exit(-1); }
	}
	//set tftp hack
	if( (replayMode == 0 && atoi(port) == 69) && (hints.ai_socktype == SOCK_DGRAM) )
		TFTP=1;
	/*We're a UDP server*/ //also includes tftp hack
	if( replayMode == 1 || TFTP==1 )
	{
		if(replayMode == 1)
			UDP_SERV=1;
		bzero(&udpaddr, sizeof(udpaddr));
	}

	printf("\n%d total legs.\n\n", Count);
	printf("Beginning replay attack:\n");
        
	/*fuzz each session according to user specified parameters*/
	///Outer loop for switching legs to fuzz
	for(currentLeg=startLeg; currentLeg<stopLeg; currentLeg++)
	{
	     if( (replayMode==0 && seq[currentLeg]==0) || (replayMode==1 && seq[currentLeg]==1))
	     {
		///Inner loop 1 for increasing the size of attack
		for(attackSize=startSize; attackSize<stopSize; attackSize=attackSize+incSize)
		{	
			if( (stopPosition==-1) || (stopPosition>DataSize[currentLeg]) ) 
				_stopPosition=DataSize[currentLeg];	
			else
				_stopPosition=stopPosition;	
			///Inner loop 2 for moving along the line (position) while using same attackSize
			for(currentPosition=startPosition; currentPosition<=_stopPosition; currentPosition++)
 			{
				///Connect to target if client mode
				if( replayMode==0)
				{
					if( sport == NULL)
					{
						if( (connfd = setup_client (res)) == ERROR) {
							TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n"); }
					}
					else
					{
						if( (connfd = setup_client_srcport (res, SRCPORT)) == ERROR) {
						TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n"); }
					}
				}
				///Accept incoming connections if TCP server mode
				if( replayMode==1 && hints.ai_socktype==SOCK_STREAM)
				{
					if( (connfd = accept(listenfd, (struct sockaddr *)NULL, NULL)) < 0) {
						TIME(); fprintf(stderr, "{{{server setup failed}}}\n\n"); exit(-1); }
				}
				///Bind to server IP for UDP
				if( replayMode==1 && hints.ai_socktype==SOCK_DGRAM )
				{
					if( (connfd = setup_server(res)) == ERROR) {
						TIME(); fprintf(stderr, "{{{Setup_server failed}}}\n\n"); exit(-1); }
				}
				//for tftp hack
				if(TFTP == 2)
				{
					TFTP=1;
					UDP_SERV=0;
				}
				///GET fd flags
				FLAG(connfd, &flags);
				///Inner loop 3.  Send, Read, Process, and/or Attack.
				_extraAttacks=extraAttacks;
				_currentLeg=currentLeg;
				tempLeg=0;
				while(tempLeg<Count)
				{
					err=0;
					usleep(delay);	
					if( (replayMode==0 && seq[tempLeg]==0) || (replayMode==1 && seq[tempLeg]==1) )
					{
						if(tempLeg!=_currentLeg)
						{
							WRITEAGAIN:
							if(userFunc)
								USERFUNC(userFuncName, 0, tempLeg, 0, currentPosition, Data[tempLeg],
												 DataSize[tempLeg], connfd, res);
							printf("[%d][-->]  ", tempLeg);
							_print(DataSize[tempLeg], printChoice, Data[tempLeg]);
								printf("\n");
							if(_write(connfd, Data[tempLeg], DataSize[tempLeg], &flags, &UDP_SERV, &udpaddr) < 1)
							{
								TIME(); perror("{{Dead Socket (W <1)}}"); break; 
							}
							tempLeg++;
							//tftp hack
							if(TFTP == 1)
								connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
						}
						else
						{
						     switch(c)
						     {
       							/*Replay verification with no attacks inserted*/
						       case 'r':
								cycleMode=1;
								currentLeg=stopLeg;
								attackSize=stopSize;
								currentPosition=_stopPosition+1;
								goto WRITEAGAIN;
							break;
							/*GPF Buffer overflow attack mode*/
						       case 'b':
							   attacked=1;
							   if(currentPosition<=DataSize[tempLeg])
							   {
								if ( (err=BufferAttack(_currentLeg, currentPosition,
									attackSize, attackChar, connfd, res, userFunc,
									userFuncName, Data, DataSize, printChoice, &flags,
									&UDP_SERV, &udpaddr)) == 1)
									break;
								tempLeg++;
								//tftp hack
								if(TFTP == 1)
									connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
								if(_extraAttacks!=0)
								{
									_extraAttacks--;
									_currentLeg++;
									for(i=tempLeg; !((replayMode==0 && seq[i]==0) ||
										(replayMode==1 && seq[i]==1)); i++ )
										_currentLeg++;
								}	
							    }
							    else
							    {
								goto WRITEAGAIN;
							    }
							break;
							/*Format string GPF attack mode*/
						       case 'f':	
							   attacked=1;
							   if(currentPosition<=DataSize[tempLeg])
							   {
								if ( (err=FormatAttack(_currentLeg, currentPosition,
									attackSize, attackChar, connfd, res, userFunc,
									userFuncName, Data, DataSize, printChoice, &flags,
									&UDP_SERV, &udpaddr)) == 1)
									break;
								tempLeg++;
								//tftp hack
								if(TFTP == 1)
									connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
								if(_extraAttacks!=0)
								{
									_extraAttacks--;
									_currentLeg++;
									for(i=tempLeg; !((replayMode==0 && seq[i]==0) ||
										(replayMode==1 && seq[i]==1)); i++ )
										_currentLeg++;
								}	
							    }
							    else
							    {
								goto WRITEAGAIN;
							    }
							break;
							/*Logic GPF attack mode*/
						       case 'l':
							   attacked=1;
							   //if(currentPosition<=DataSize[tempLeg]) //fixes membug
							   if(currentPosition<DataSize[tempLeg])
							   {
								if ( (err=LogicAttack(_currentLeg, currentPosition,
									attackSize, attackChar, connfd, res, userFunc,
									userFuncName, Data, DataSize, printChoice, &flags,
									&UDP_SERV, &udpaddr)) == 1)
									break;
								tempLeg++;
								//tftp hack
								if(TFTP == 1)
									connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
								if(_extraAttacks!=0)
								{
									_extraAttacks--;
									_currentLeg++;
									for(i=tempLeg; !((replayMode==0 && seq[i]==0) ||
										(replayMode==1 && seq[i]==1)); i++ )
										_currentLeg++;
								}	
							    }
							    else
							    {
								goto WRITEAGAIN;
							    }
							break;
						       default:
								fprintf(stderr, "{{{Bad attack mode: use r, b, f, l}}}\n\n");
								GPF_usage();
			   			  }
						}
					    	if (attacked==1)
						{
							attacked=0;
							if(err)	
								break;	
							if( (cycleMode==0) && (_extraAttacks==0) )
								break;
						}
					}
					else if( (replayMode==0 && seq[tempLeg]==1) || (replayMode==1 && seq[tempLeg]==0) )
					{
						READAGAIN:
						if( (x=_read(connfd, &flags, &UDP_SERV, &UDP_SERV_READ, &TFTP, Data, readData,
						readDataSize, tempLeg, readWait, &udpaddr, printChoice)) == -2) {
							perror("{{Couldn't Read Socket (R -2)}}"); }
						else if(x == -1) {
							TIME(); perror("{{Dead Socket (R -1)}}"); break; }
						if(userFunc)
						{
							y=USERFUNC(userFuncName, x, tempLeg, 1, currentPosition, readData[tempLeg],
											readDataSize[tempLeg], connfd, res);
							if( y==-1)
							{
								printf("{{Didn't like what we got...Let's read again.}}\n");
								goto READAGAIN;
							}
							if( y==1)
							{
								printf("{{Didn't like what we got...Let's write again.}}\n");
								tempLeg--;
								goto WRITEAGAIN;
							}
						}
						tempLeg++;
					}
					else
					{
						TIME();fprintf(stderr, "{{{Bad replayMode or seq[]}}}\n");exit(-1);
					}
				}
				///Clean up and head to the bottom of this big o' loop	
				printf("=================================Total Loops: %d====================================\n\n", loops);
				loops++;
				if(userFunc)
					USERFUNC(userFuncName, 0, _currentLeg, 4, currentPosition, 0, 0, connfd, res);
				usleep(delay);
				close(connfd);
				if(userFunc)
					USERFUNC(userFuncName, 0, _currentLeg, 5, currentPosition, 0, 0, connfd, res);
				///Checks to be sure we went around at least once
				if(!loopedOnce)
					loopedOnce=1;
				UDP_SERV_READ=0;
			}
		}
	    }
	}
}
