/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"
  
/*Convert mode - allows you to convert a libpcap file to a text file*/
int convert_mode(int argc, char ** argv)
{
	/*Variable Definitions*/
        int fp_src, fp_dst;

	//It's a bit ugly have these static.
        //Up these if you have a maga huge session to replay
        u_int seq[3000];  //order in which legs took place  0=client speaking; 1=server speaking
        void * Data[1500]; //master list of each of the legs in order
        u_int DataSize[1500];  //used to hold the size of each pkt data
        u_int Count=0;  //total number of client and server legs
        u_int firstTime = 1;
	ip_address clientIP;
        ip_address serverIP;

        /*prepare the above args into a strange format for the pcap_loop func within, call_readin*/
        void * args[7];
        args[0] = seq;
        args[1] = Data;
        args[2] = DataSize;
        args[3] = &Count;
        args[4] = &firstTime;
        args[5] = &clientIP;
        args[6] = &serverIP;

	/* check args.  */
        if (argc < 3) {
       		TIME(); fprintf(stderr, "{{{Not enough args}}}\n"); exit(-1); } 

	/*open files with error check*/
        umask(0);
        if( (fp_dst = open(argv[3], O_WRONLY|O_CREAT, 0666)) <0) {
                TIME(); fprintf(stderr, "{{{Couldn't open dst_file.}}}\n"); exit(-1); }
	/*Calls readin which reads ethereal dump into the global array*/
	if ( call_readin(argv[2], (u_char *)args) !=0) {
		TIME(); fprintf(stderr, "{{{Problem reading in capture file!}}}\n\n"); exit(-1); }

	/*write global data out to txt.gpf type file*/
	txt_write(fp_dst, seq, Data, DataSize, &Count);

	/*close file descriptor*/
        if( (close(fp_dst) < 0)) {
                perror("close fp_dst"); exit(-1); }
	printf("\n\n\tDone.\n\n");
}
