/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com
    Copyright (c) 2007, VDA Labs, LLC
    Jared DeMott, jdemott@vdalabs.com, www.vdalabs.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

//Usages
random_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Random fuzzing Mode (-R +|x-y)\n");
printf("Usage: GPF <ModeArgs> <hostname/IP> <PORT> <SPORT> <TCP/UDP> <SEED> <DELAY>\n");
     printf("\tModeArgs = '-R +|x-y'\n");
	printf("\t\tCan specify a range of pkts to send; put only + to send all\n");
     printf("\tIP = IP address of target. [localhost]\n");
     printf("\tPORT = Destination port. [21]\n");
     printf("\tSPORT = Source port. Use a ? for don't care. [?]\n");
     printf("\tTCP/UDP = Protocol type. [TCP]\n");
     printf("\tSEED = Any string of numbers (Allows a successful attack to be repeated). [82645286]\n");
     printf("\tDELAY = Any number of microseconds. [1000]\n\n\n");

printf("'-h R' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}


FileFuzz_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott, VDA Labs, LLC\n\n");

printf("FileFuzz GPF mode\n");
printf("Fuzzes an example file based on tokenization and dumps files in a directory\n");
printf("Use the associated pydbg script (gpf_file_fuzzer.py) to deliever files/monitor target application.\n");
printf("Usage: GPF -F <ExampleFile> <DumpDir> <SEED> <NumFiles> <UserFunc> <TokPrint> <TokAid> <MutationRate>\n");
     printf("\t-F = Tokenizes each piece of each leg and inserts random attacks based on patterns; for files.\n");
     printf("\tExampleFile = Filename of the example file to tokenize and fuzz. [poop.pdf]\n");
     printf("\tDumpDir = GPF will create this (_+name) for you if input 'same'. [same]\n");
     printf("\t\tNote: If the dir already exists GPF will not overwrite it; you must delete if you want to.\n");
     printf("\tSEED = For repeatable randomness (allows a successful attack to be repeated). [78883310]\n");
     printf("\tNumFiles = Number of fuzzy files to dump to dir. [5000]\n");
     printf("\tUserFunc = Name of user defined code.  Use 'none' if none. [none]\n");
     printf("\tTokPrint = Print parsed toks at start of replay for FYI/debugging. Use either 'long' or 'short'. [short]\n");
     printf("\tTokAid = Name of code that will help parse file protocol.  Use 'NONE' if none. [GENERIC_ASCII]\n");
     printf("\tMutationRate = Rate of Mutations: 'high', 'med', or 'low'. [med]\n\n\n");

printf("'-h P' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

doctor_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Convert Mode\n");
printf("Usage: GPF -C <filein> <fileout>\n");
     printf("\tfilein = pcap file to read in\n");
     printf("\tfileout = fileanme to output converted txt.gpf\n\n\n");

printf("'-h C' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}


GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("GPF mode (-G b|f|l|r)\n");
printf("Usage: GPF <AttackMode> <CaptureFile> <ReplayMode> <hostname/IP> <PORT> <SPORT> <TCP/UDP> <SEED> <DELAY> <LStart> <LStop> <PStart> <PStop> <AStart> <AInc> <AStop> <AChar> <CycleMode> <extraAttacks> <ReadWait> <PrintChoice> <UserFunc>\n");
     printf("\tAttackMode Args = '-G r|b|f|l'  [-G b]\n");
	printf("\t\tr : Replay - For verification; no attack but can still use userFunc. Starts at LINE.\n");
	printf("\t\tb : Buffer overflow attack\n");
	printf("\t\tf : Format bug attack  (6e is n; a good choice when searching for format bugs)\n");
	printf("\t\tl : Logic (bit flipping) attack - AStart, Inc, Stop, and Char have special meaning - See README.\n");
            printf("\t\t\tUse AStart, AInc, and AStop to count how many times. POS and AChar have no meaning.\n");
     printf("\tCaptureFile = File name of the captured traffic to replay. [mycapture.gpf]\n");
     printf("\tReplayMode = 'client' (test servers); 'server' (test clients). [client]\n");
     printf("\tIP = IP address of target or IP address to bind to. [localhost]\n");
     printf("\tPORT = Destination port or Port to listen on. [21]\n");
     printf("\tSPORT = Source port. Use a ? for don't care. Only affects client mode. [?]\n");
     printf("\tTCP/UDP = Protocol type. [TCP]\n");
     printf("\tSEED = For repeatable randomness (allows a successful test to be repeated). [82645286]\n");
     printf("\tDELAY = Any number of microseconds [1000]\n");
     printf("\tLStart = Decimal packet number (which 'leg' of the session) to begin fuzzing on. [0]\n");
     printf("\tLStop = Decimal packet number (which 'leg' of the session) to stop fuzzing at. [+] (+ = all legs)\n");
     printf("\tPStart = Decimal position in the data (if 40bytes of data, then 1-40;if>max skip leg) to begin fuzzing at. [0]\n");
     printf("\tPStop = Decimal position in the data (if 40bytes of data, then 1-40) to stop fuzzing at. [+] (+ = max position)\n");
     printf("\tAStart = Decimal sized number of bytes to start attacking with. [0]\n");
     printf("\tAInc = Decimal size number of bytes to increment attack by. [255]\n");
     printf("\tAStop = Decimal size number of bytes to stop at. [17000]\n");
     printf("\tAChar = Hex character to fill attack buffer with. Use the from 41 for 'A', etc.\n");
	printf("\t\tIf AChar equal to 43, then fill with random data (for all three modes). [6e]\n");
     printf("\tCycleMode = 'close' fd after each attack, or 'finish' replaying as much of capture file as possible. [finish]\n");
     printf("\tExtraAttacks = Normal is 1 attackleg/session.  This option allows for multile attacklegs/session. [0]\n");
     printf("\tReadWait = How many seconds to wait in a read if data is not availible. [3]\n");
     printf("\tPrintChoice = Print choice in which to display the session - ascii; hex; auto. [auto]\n");
     printf("\tUserFunc = Name of user defined code.  Use 'none' if none. [none]\n\n\n");

printf("'-h G' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

Pattern_GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Pattern (Tokenizer) GPF mode\n");
printf("Usage: GPF -P <CaptureFile> <ReplayMode> <hostname/IP> <PORT> <SPORT> <TCP/UDP> <SEED> <DELAY> <ReadWait> <PrintChoice> <UserFunc> <TokPrint> <TokAid> <MutationRate> <OnSessionSetupError>\n");
     printf("\t-P = Pattern Matching tokenizes each piece of each leg and inserts random attacks based on patterns.\n");
     printf("\tCaptureFile = File name of the captured traffic to tokenize and replayFuzz. [mycapture]\n");
     printf("\tReplayMode = 'client' (test servers); 'server' (test clients). [client]\n");
     printf("\tIP = IP address of target or IP address to bind to. [localhost]\n");
     printf("\tPORT = Destination port or Port to listen on. [21]\n");
     printf("\tSPORT = Source port. Use a ? for don't care. Only affects client mode. [?]\n");
     printf("\tTCP/UDP = Protocol type. [TCP]\n");
     printf("\tSEED = For repeatable randomness (allows a successful attack to be repeated). [78883310]\n");
     printf("\tDELAY = Any number of microseconds. [2000]\n");
     printf("\tReadWait = How many seconds to wait in a read if data is not availible. [3]\n");
     printf("\tPrintChoice = Print choice in which to display the session - 'ascii'; 'hex'; 'auto'. [AUTO]\n");
     printf("\tUserFunc = Name of user defined code.  Use 'none' if none. [none]\n");
     printf("\tTokPrint = Print parsed toks at start of replay for FYI/debugging. Use either 'long' or 'short'. [short]\n");
     printf("\tTokAid = Name of code that will help parse protocol.  Use 'NONE' if none. [GENERIC_ASCII]\n");
     printf("\tMutationRate = Rate of Mutations: 'high', 'med', or 'low'. [med]\n");
     printf("\tOnSessionSetupError = If TCP session setup fails either 'CONTINUE' or 'QUIT'. [CONTINUE]\n\n\n");

printf("'-h P' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

Evolving_GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Evolutionary GPF mode\n");
printf("Usage: GPF -E <Mysql host> <Mysql user> <Mysql passwd> <ID> <StartingGen> <PaiMei host> <PaiMei PORT> <StalkType> <PlayMode> <HOST> <PORT> <SPORT> <TCP/UDP> <DELAY> <Wait> <DisplayLevel> <PrintChoice> <Pools> <Sessions> <Fixed/Max> <Legs> <Fixed/Max> <Toks> <Fixed/Max> <Generations> <SessionMutationRate> <PoolCrossoverRate> <PoolMutationRate> <UserFunc> <SeedFile> <proxy> <Diversity>\n");
     printf("\tMysql Host = Hostname or IP address of the Mysql server. [WindowsBox]\n");
     printf("\tMysql user = Mysql user. [user]\n");
     printf("\tMysql passwd = Mysql passwd. [passwd]\n");
     printf("\tID = This Mysql ID will be need to continue from previous runs. [0]\n");
     printf("\tStarting Generation = Use zero for a new run. n to continue from a previously saved run. [0]\n");
     printf("\tOn save, if the ID/gen (in mysqldb) contains data, the saved generation is deleted to make room for new data.\n");
     printf("\tAlso, if you restart and ID with gen==0 all data for that ID is deleted.\n");
     printf("\tPaiMei Host = Hostname or IP address of the PaiMei (debugger) server. [WindowsBox]\n");
     printf("\tPaiMei PORT = Destination port of the PaiMei (debugger) server. [31338]\n");
     printf("\tPaiMei stalk type = 'funcs' or 'basic_blocks'. [funcs]\n");
     printf("\tPlayMode = 'client' (test servers); 'server' (test clients). [client]\n");
     printf("\tHOST = Hostname or IP address of target or IP address to bind to. [localhost]\n");
     printf("\tPORT = Destination port or Port to listen on. [21]\n");
     printf("\tSPORT = Source port. Use a ? for don't care. Only affects client mode. [?]\n");
     printf("\tTCP/UDP = Protocol type. [TCP]\n");
     printf("\tDELAY = Any number of microseconds. [2000]\n");
     printf("\tWait = How many clicks to wait in a read/write if data is not availible/couldn't send. [20]\n");
     printf("\tA click is .01 sec. So 20 would be .2 of a second.\n");
     printf("\tDisplayLevel = Various levels of printed details as we run - 'low'; 'med'; 'high'. [low]\n");
     printf("\tPrintChoice = Print choice in which to display the session - 'ascii'; 'hex'; 'auto'. [AUTO]\n");
     printf("\tPools = Number of (genotype) pools. [4]\n");
     printf("\tSessions/Pool = Number of (genotypes) sessions/pool. [25]\n");
     printf("\tFixed/Max = Should the previous number be Fixed or a Max? [Fixed]\n");
     printf("\tLegs/session = Maximum number of legs/session. [10]\n");
     printf("\tFixed/Max = Should the previous number be Fixed or a Max? [Fixed]\n");
     printf("\tTokens/leg = Maximum number of tokens/leg. [10]\n");
     printf("\tFixed/Max = Should the previous number be Fixed or a Max? [Fixed]\n");
     printf("\tGenerations = Number of generations to run. [400]\n");
     printf("\tSession crossover (within a pool) occurs each generation to create totally new sessions in each pool.\n");
     printf("\tSessionMutationRate = Mutate 2 toks (1 data, 1 type) in each session only every X generations. [3]\n");
     printf("\tPoolCross0verRate = Crossover pools (creates newly ordered sessions in each pool) every X generations. [5]\n");
     printf("\tPoolMutationRate = Insert or delete a random session from each pool every X generations. [9]\n");
     printf("\tUserFunc = Name of user defined code. (Not yet tested for -E mode.)  Use 'none' if none. [none]\n");
     printf("\tSeedFile = File that contains seed strings that may be hard to randomly guess. Use 'none' if none. [X_cmds.seed]\n");
     printf("\tProxy = Use 'yes' or 'no'. If yes, the HOST/PORT from above will point the the proxy. [no]\n");
     printf("\tDiversity = 0=no fitness boost for diverse sessions/pools; 1=give a boost. [1]\n\n\n");

printf("'-h E' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

Replay_evolving_GPF_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("Replay evolving GPF mode\n");
printf("Usage: GPF -X <Mysql host> <Mysql user> <Mysql passwd> <ID> <StartingGen> <EndingGen> <PlayMode> <HOST> <PORT> <SPORT> <TCP/UDP> <DELAY> <Wait> <DisplayLevel> <PrintChoice> <UserFunc> <proxy>\n");
     printf("\tMysql Host = Hostname or IP address of the Mysql server. [WindowsBox]\n");
     printf("\tMysql user = Mysql user. [user]\n");
     printf("\tMysql passwd = Mysql passwd. [passwd]\n");
     printf("\tID = This Mysql ID will be need to continue from previous runs. [0]\n");
     printf("\tStarting Generation = Generation number to begin replaying from mysql db. [xx]\n");
     printf("\tEnding Generation = Generation number to end at. [xx]\n");
     printf("\tPlayMode = 'client' (test servers); 'server' (test clients). [client]\n");
     printf("\tHOST = Hostname or IP address of target or IP address to bind to. [localhost]\n");
     printf("\tPORT = Destination port or Port to listen on. [21]\n");
     printf("\tSPORT = Source port. Use a ? for don't care. Only affects client mode. [?]\n");
     printf("\tTCP/UDP = Protocol type. [TCP]\n");
     printf("\tDELAY = Any number of microseconds. [2000]\n");
     printf("\tWait = How many seconds to wait in a read/write if data is not availible/couldn't send. [1]\n");
     printf("\tDisplayLevel = Various levels of printed details as we run - 'low'; 'med'; 'high'. [low]\n");
     printf("\tPrintChoice = Print choice in which to display the session - 'ascii'; 'hex'; 'auto'. [AUTO]\n");
     printf("\tUserFunc = Name of user defined code. (Not yet tested for -E mode.)  Use 'none' if none. [none]\n");
     printf("\tProxy = Use 'yes' or 'no'. If yes, the HOST/PORT from above will point the the proxy. [no]\n\n\n");

printf("'-h X' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

main_usage()
{
printf("\nGeneral Purpose Fuzzer (GPF) - By: Jared DeMott\n\n");

printf("'-h R' for the pure fuzz usage\n");
printf("'-h C' for the convert usage\n");
printf("'-h G' for the basic GPF usage\n");
printf("'-h P' for the Pattern Matching GPF usage\n");
printf("'-h p' for the newer Pattern Matching GPF usage ((don't use, not done))\n");
printf("'-h E' for the Evolutionary Fuzzer System (GPF portion) usage\n");
printf("'-h X' for the Replay Evolutionary data from mysqldb\n");
printf("'-h' for this usage\n\n\n");
printf("NOTE: Be sure to enter vaild command line options as only marginal vaildation is preformed inside GPF\n\n\n");
     exit (-1);
}

/*Calculate the range for the pure fuzz fuction*/
int calcRange(unsigned int * none, unsigned int * x, unsigned int * y, char * optarg)
{
        char * middle;

        if(optarg == NULL)
                *(none)=1;
        else if ( strchr(optarg, '+'))
                *(none)=1;
        else
        {
                *(none)=0;
                if ( (middle=strchr(optarg, '-')) == NULL)
                {
                        printf("should be of the exact form '-R x-y'.\n");
                        return(-1);
                }
                *(middle)=0x00;
                *(x)=atoi(optarg);
                *(y)=atoi(middle+1);
        }
}

/*print out when an error occured*/
void TIME()
{
	struct tm *tm;
	u_char buf[100];
	time_t now;

	now = time(NULL);
	tm = localtime(&now);
	if(strftime(buf, sizeof(buf), "%b %d %H:%M:%S", tm) > 0)
		fprintf(stderr,"\nTime of error: %s, Error:", buf);
}	

/*Calls userFunc*/
/*index is the leg of protocol*/
/*location indicates one of three spots that USERFUNC is called
0=before pre_write_loop, 1=after pre_read_loop, 2=pre_attack construction, 3=pre_send attack, 4=pre_close, 5=after close
(these are old and probably need to be updated.
*/
int USERFUNC(char * userFuncName, int readRet, u_int index, u_int location, u_int currentPosition, u_char * currentPkt, u_int currentPktLen, int connfd, struct addrinfo *res)
{
	int ret;

	if( (strcasecmp(userFuncName, "jabber")) == 0)
		jabber(index, location, currentPkt, connfd, res);
	else if( (strcasecmp(userFuncName, "db_OtoR")) == 0)
		db_OtoR(index, location, connfd, res);
	else if( (strcasecmp(userFuncName, "db_RtoA")) == 0)
		db_RtoA(index, location, connfd, res);
	else if( (strcasecmp(userFuncName, "isakmp")) == 0)
		ret=isakmp(readRet, index, location, currentPosition, currentPkt, currentPktLen);
	else if( (strcasecmp(userFuncName, "isakmp_serv")) == 0)
		ret=isakmp_serv(readRet, index, location, currentPosition, currentPkt, currentPktLen);
	else if( (strcasecmp(userFuncName, "dns_serv")) == 0)
		ret=dns_serv(index, location, currentPkt);
	else if( (strcasecmp(userFuncName, "dns")) == 0)
		ret=dns();
	else { fprintf(stderr, "{{{Bad userFunc}}}\n"); return ERROR; }
	
	return ret;
}

/*Read the example file data and sizes in the master arrays*/
int filefuzz_readin(u_char * file, u_int * seq, void ** Data, u_int * DataSize, u_int * Count)
{
	/*local vars*/	
	int fp_src;
	int fsize=0;
	int x=0;
	int y=0;
	int block=1024;
	u_char blockptr[block];
	u_char * fileData=NULL;

	/*open files with error check*/
        umask(0);
        if( (fp_src = open(file, O_RDONLY|O_CREAT, 0666)) <0) {
                TIME(); fprintf(stderr, "{{{Couldn't open file.}}}\n"); return(-1); }
	/*read data into array*/
	while ( (x=read(fp_src, blockptr, block)) >0 )
	{
		if(x>0)
			fsize=fsize+x;
		fileData=realloc(fileData, fsize);
		memcpy(fileData+y, blockptr, x);
		if(x>0)
			y=y+x;
	}
	if(fsize == 0){
		TIME(); fprintf(stderr, "{{{NULL FILE - filefuzz_readin}}}\n"); return(-1);}
	/*add data to the goofy global thing I created long ago, for a reason now unknown to me. :)*/
	DataSize[*Count]= y;	
	Data[*Count]=_malloc(DataSize[*Count]);
       	memcpy(Data[*Count], fileData, DataSize[*Count]);

	/*close file descriptor*/
        if( (close(fp_src) <0)) {
                perror("close fp_src"); return(-1); }

	free(fileData);
}

/*Write fuzzy file data to disk*/
int write_file(char * filename, u_char * data, u_int data_len)
{
	/*local vars*/	
	int fp_src;
	int x=0;

	/*open files with error check*/
        umask(0);
        if( (fp_src = open(filename, O_WRONLY|O_CREAT, 0666)) <0) {
                TIME(); fprintf(stderr, "{{{Couldn't open file.}}}\n"); return(-1); }
	/*read data into array*/
	x=write(fp_src, data, data_len);
	if(x == ERROR)
		perror("{{Problem writing to file!}}");

	/*close file descriptor*/
        if( (close(fp_src) <0)) {
                perror("close fp_src"); return(-1); }
	return OK;
}

/*Read the txt.gpf data and sizes in the master arrays*/
int txt_readin(u_char * file, u_int * seq, void ** Data, u_int * DataSize, u_int * Count)
{
	/*local vars*/	
	int fp_src;
	int fsize=0;
	int x=0;
	int y=0;
	int block=256;
	u_char blockptr[block];
	u_char * fileData=NULL;
	u_char * ptr=NULL;

	/*open files with error check*/
        umask(0);
        if( (fp_src = open(file, O_RDONLY|O_CREAT, 0666)) <0) {
                TIME(); fprintf(stderr, "{{{Couldn't open src_file.}}}\n"); return(-1); }
	/*read data into array*/
	while ( (x=read(fp_src, blockptr, block)) >0 )
	{
		if(x>0)
			fsize=fsize+x;
		fileData=realloc(fileData, fsize);
		memcpy(fileData+y, blockptr, x);
		if(x>0)
			y=y+x;
	}
	if(fsize == 0){
		TIME(); fprintf(stderr, "{{{NULL FILE - txt_readin}}}\n"); return(-1);}
	/*parse data and store in global arrays*/
	ptr=fileData;
	while ( 1 )	
	{
		if( (ptr=strstr(ptr, "Source:")) !=NULL )
		{
			if ( *(ptr+7)=='C')
			{
				ptr=strstr(ptr, "Size:");
				DataSize[*Count]= (atoi(ptr+5));	
				ptr=strstr(ptr, "Data:");
				if( DataSize[*Count] > 0)
				{
					Data[*Count]=_malloc(DataSize[*Count]);
               				memcpy(Data[*Count], ptr+5, DataSize[*Count]);
					ptr=ptr+5+DataSize[*Count];
					seq[*Count]=0;
        				(*Count) = (*Count) + 1;
				}
			}
			else if ( *(ptr+7)=='S')
			{
				ptr=strstr(ptr, "Size:");
				DataSize[*Count]= (atoi(ptr+5));	
				ptr=strstr(ptr, "Data:");
				if( DataSize[*Count] > 0)
				{
					Data[*Count]=_malloc(DataSize[*Count]);
               				memcpy(Data[*Count], ptr+5, DataSize[*Count]);
					ptr=ptr+5+DataSize[*Count];
					seq[*Count]=1;
        				(*Count) = (*Count) + 1;
				}
			}
			else{
				TIME(); fprintf(stderr, "{{{Bad Source - txt_readin: *Count=%d}}}\n", *Count); return(-1);}
		}
		else
			break;
	}
	/*close file descriptor*/
        if( (close(fp_src) <0)) {
                perror("close fp_src"); return(-1); }
}

/*Write master array out to txt.gpf style file*/
int txt_write(int fd, u_int * seq, void ** Data, u_int * DataSize, u_int * Count)
{
	/*local vars*/	
	int i, lineSize;
	u_char buf[1600];
	
	/*parse data and store in global arrays*/
	for(i=0; i<(*Count); i++)	
	{
		memset(buf, 0x00, 1600);
		if(seq[i])
		{
			snprintf(buf,1599, "Source:S Size:%.4d Data:", DataSize[i]);
			lineSize=(strlen(buf) + DataSize[i]);
			memcpy(buf+(strlen(buf)), Data[i], DataSize[i]);
		}
		else
		{
			snprintf(buf,1599, "Source:C Size:%.4d Data:", DataSize[i]);
			lineSize=(strlen(buf) + DataSize[i]);
			memcpy(buf+(strlen(buf)), Data[i], DataSize[i]);
		}
		if ( write(fd, buf, lineSize) < 1){
			TIME(); perror("{{{write proble in txt_write()}}}"); return(-1);}
	}
	printf("\nWriting %d lines to file...\n", i);
}

/*Reads in and copies pkt data into global array*/
void readin(u_char * args, const struct pcap_pkthdr *header, const u_char *pkt_data)
{
	void ** Args = (void **)args;

	u_int * seq = Args[0];
	void ** Data = Args[1];
	u_int * DataSize = Args[2];
	u_int * Count = Args[3];
	u_int * firstTime = Args[4];
	ip_address * clientIP = Args[5];
        ip_address * serverIP = Args[6];

	u_int layer2Len=14;  ///14 bytes is the length of ethernet
        u_int i, IPlen, TCPlen, UDPlen, dataLen;
        ip_header *IPheader;
        tcp_header *TCPheader;
        udp_header *UDPheader;
        u_char * data;


        /* Get the position of the ip header */
        IPheader = (ip_header *)(pkt_data + layer2Len);
        IPlen = (IPheader->ver_ihl & 0xf) * 4;

	/*The first time through we set the client & server IP*/
	/*I suppose we could handle more/diff IPs if we wanted...*/
	if ( *firstTime == 1 )
	{
		*firstTime = 0;
		*clientIP = IPheader->saddr;
		*serverIP = IPheader->daddr;
		printf("\nFound in Capture file:\nclientIP=%d.%d.%d.%d --> ", clientIP->byte1, clientIP->byte2, clientIP->byte3, clientIP->byte4);
		printf("serverIP=%d.%d.%d.%d\n",serverIP->byte1, serverIP->byte2, serverIP->byte3, serverIP->byte4);
		fflush(stdout);
	}
		

	/*Handle TCP*/
        if(IPheader->protocol==0x06)
	{
		///Set TCPheader and calculate data length
                TCPheader = (tcp_header *) ((u_char*)IPheader + IPlen);
                TCPlen= ((TCPheader->hlen & 0xf0) >> 4) * 4;
                dataLen=( (header->len)-layer2Len-IPlen-TCPlen);

		///If there's data (plus check if PSK/ACK) put it in appropriate array
		///if ( (dataLen>0) && (TCPheader->flags==0x18) )
		///Since data can also be in just ACK's had to change to
		if ( (dataLen>0) && (memcmp((u_char *)(pkt_data+layer2Len+IPlen+TCPlen), "\x00\x00\x00\x00\x00\x00", 6) !=0) )
		{
			if(IPheader->saddr.byte3==clientIP->byte3 && IPheader->saddr.byte4==clientIP->byte4)
			{
				DataSize[*Count]=dataLen;	
				Data[*Count]=_malloc(dataLen);
                		memcpy(Data[*Count], (u_char *)(pkt_data+layer2Len+IPlen+TCPlen), dataLen);
				seq[*Count]=0;
				printf("[%d] CLIENT message\n", *Count);
        			*(Count)=*(Count) + 1;
			}
			else if(IPheader->saddr.byte3==serverIP->byte3 && IPheader->saddr.byte4==serverIP->byte4)
			{	
				DataSize[*Count]=dataLen;	
				Data[*Count]=_malloc(dataLen);
                		memcpy(Data[*Count], (u_char *)(pkt_data+layer2Len+IPlen+TCPlen), dataLen);
				seq[*Count]=1;
				printf("[%d] SERVER message\n", *Count);
        			*(Count)=*(Count) + 1;
			}
			else
				printf("Bad IP found in capture file: Not client or server!\n");
		}
        }

	/*Handle UDP*/
        if(IPheader->protocol==0x11)
	{
		///Set UDPheader and calculate data length
                UDPheader = (udp_header *) ((u_char*)IPheader + IPlen);
                UDPlen= 8;
                dataLen=( (header->len)-layer2Len-IPlen-UDPlen);
		
		///If there's data put it in the appropriate array
		if ( (dataLen>0) )
		{
			if(IPheader->saddr.byte3==clientIP->byte3 && IPheader->saddr.byte4==clientIP->byte4)
			{
				DataSize[*Count]=dataLen;	
				Data[*Count]=_malloc(dataLen);
                		memcpy(Data[*Count], (u_char *)(pkt_data+layer2Len+IPlen+UDPlen), dataLen);
				seq[*Count]=0;
				printf("[%d] CLIENT message\n", *Count);
        			*(Count)=*(Count) + 1;
			}
			else if(IPheader->saddr.byte3==serverIP->byte3 && IPheader->saddr.byte4==serverIP->byte4)
			{	
				DataSize[*Count]=dataLen;	
				Data[*Count]=_malloc(dataLen);
                		memcpy(Data[*Count], (u_char *)(pkt_data+layer2Len+IPlen+UDPlen), dataLen);
				seq[*Count]=1;
				printf("[%d] SERVER message\n", *Count);
        			*(Count)=*(Count) + 1;
			}
			else
				printf("Bad IP found in capture file: Not client or server!\n");
		}
        }

	/*Handle ICMP*/
        if(IPheader->protocol==0x01)
	{
                printf(" ICMP ");
        }
}

/* calls readin*/
int call_readin(u_char * dumpin, u_char * args)
{
    pcap_t *fp;
    u_char errbuf[PCAP_ERRBUF_SIZE];

    /* Open capture file */
    if ( (fp = pcap_open_offline(dumpin, errbuf) ) == NULL)
    {
        TIME(); fprintf(stderr,"{{{errbuf=%s}}}\n", errbuf); return -1;
    }
    
    /* Loop over the readin function*/
    if ( (pcap_loop(fp, 0, readin, args)) == -1)
    {
        TIME(); perror("pcap_loop error"); return -1;
    }
	
return 0;
}

int BufferAttack(u_int currentLeg, u_int currentPosition, u_int attackSize, u_int attackChar, int connfd, struct addrinfo *res, u_int userFunc, u_char * userFuncName, void ** Data, u_int * DataSize, u_int printChoice, int * flags, int * UDP_SERV, void * udpaddr)
{
	u_int totalLen=0;
	u_int i=0;
	int ret=0;
	u_char * Packet=NULL;
	u_char * half1=NULL;
	u_char * half2=NULL;

	///process and construct the attack line
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 2, currentPosition, 0, 0, connfd, res);
	totalLen=attackSize+DataSize[currentLeg];
	Packet=_malloc(totalLen);
	half1=_malloc(totalLen);
	half2=_malloc(totalLen);
	memset(Packet, 0x00, totalLen);
	memset(half1, 0x00, totalLen);
	memset(half2, 0x00, totalLen);
	if(currentPosition==0)
	{
		if(attackChar==0x43)
		{
			for(i=0;i<attackSize;i++) { Packet[i]=_rand(256); }
			memcpy( Packet+attackSize, Data[currentLeg], DataSize[currentLeg]);
		}
		else
		{
			memset(Packet, attackChar, attackSize);
			memcpy(Packet+attackSize, Data[currentLeg], DataSize[currentLeg]); 	
		}
	}
	else
	{
		memcpy(half1, Data[currentLeg], currentPosition);
		memcpy(half2, Data[currentLeg]+currentPosition, DataSize[currentLeg]-currentPosition);
		memcpy(Packet, half1, currentPosition);
		if(attackChar==0x43)
		{
			for(i=0;i<attackSize;i++) { Packet[i+currentPosition]=_rand(256); }
			memcpy(Packet+currentPosition+attackSize, half2, DataSize[currentLeg]-currentPosition);
		}
		else
		{
			memset(Packet+currentPosition, attackChar, attackSize);
			memcpy(Packet+currentPosition+attackSize, half2, DataSize[currentLeg]-currentPosition); 	
		}
	}
	///process and print attack
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 3, currentPosition, Packet, totalLen, connfd, res);
	if (currentPosition==0)
	{
		printf("[%d][-%d->]  [b-0]",currentLeg, attackSize);
		_print(DataSize[currentLeg], printChoice, Data[currentLeg]);
			printf("\n");
	}
	else
	{
		printf("[%d][-%d->] ",currentLeg, attackSize);
		_print(currentPosition, printChoice, half1);
		printf("[b-%d]", currentPosition);
		_print(DataSize[currentLeg]-currentPosition, printChoice, half2);
			printf("\n");
	}
	//send attack
	if(_write(connfd, Packet, totalLen, flags, UDP_SERV, udpaddr) < 1) {
		ret=1; TIME(); perror("{{{Buffer attack write error -- quit and loop}}}"); }
	free(Packet);
	free(half1);
	free(half2);
	return ret;
}

int FormatAttack(u_int currentLeg, u_int currentPosition, u_int attackSize, u_int attackChar, int connfd, struct addrinfo *res, u_int userFunc, u_char * userFuncName, void ** Data, u_int * DataSize, u_int printChoice, int * flags, int * UDP_SERV, void * udpaddr)
{
	u_int totalLen=0;
	u_int i=0;
	int ret=0;
	u_char * Packet=NULL;
	u_char * half1=NULL;
	u_char * half2=NULL;

	///process and construct the attack line
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 2, currentPosition, 0, 0, connfd, res);
	totalLen=(2*attackSize)+DataSize[currentLeg]; ///Times 2 for the %'s
	Packet=_malloc(totalLen);
	half1=_malloc(totalLen);
	half2=_malloc(totalLen);
	memset(Packet, 0x00, totalLen);
	memset(half1, 0x00, totalLen);
	memset(half2, 0x00, totalLen);
	if(currentPosition==0)
	{
		if(attackChar==0x43)
		{
			for(i=0;i<(2*attackSize);i=i+2)
			{
				Packet[i]='%';
				Packet[i+1]=_rand(128); 
			}
			memcpy( Packet+(2*attackSize), Data[currentLeg], DataSize[currentLeg]);
		}
		else
		{
			for(i=0;i<(2*attackSize);i=i+2)
			{
				Packet[i]='%';
				Packet[i+1]=attackChar; 
			}
			memcpy(Packet+(2*attackSize), Data[currentLeg], DataSize[currentLeg]); 	
		}
	}
	else
	{
		memcpy(half1, Data[currentLeg], currentPosition);
		memcpy(half2, Data[currentLeg]+currentPosition, DataSize[currentLeg]-currentPosition);
		memcpy(Packet, half1, currentPosition);
		if(attackChar==0x43)
		{
			for(i=0;i<(2*attackSize);i=i+2)
			{
				Packet[i+currentPosition]='%';
				Packet[i+1+currentPosition]=_rand(128);
			}
			memcpy(Packet+currentPosition+(2*attackSize), half2, DataSize[currentLeg]-currentPosition);
		}
		else
		{
			for(i=0;i<(2*attackSize);i=i+2)
			{
				Packet[i+currentPosition]='%';
				Packet[i+1+currentPosition]=attackChar; 
			}
			memcpy(Packet+currentPosition+(2*attackSize), half2, DataSize[currentLeg]-currentPosition); 	
		}
	}	
	///process, send, and print attack
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 3, currentPosition, Packet, totalLen, connfd, res);
	if (currentPosition==0)
	{
		printf("[%d][-%d->]  [f-0]",currentLeg, attackSize);
		_print(DataSize[currentLeg], printChoice, Data[currentLeg]);
			printf("\n");
	}
	else
	{
		printf("[%d][-%d->] ",currentLeg, attackSize);
		_print(currentPosition, printChoice, half1);
		printf("[f-%d]", currentPosition);
		_print(DataSize[currentLeg]-currentPosition, printChoice, half2);
			printf("\n");
	}
	//send attack
	if(_write(connfd, Packet, totalLen, flags, UDP_SERV, udpaddr) < 1) {
		ret=1; TIME(); perror("{{{Format attack write error -- quit and loop}}}"); }
	free(Packet);
	free(half1);
	free(half2);
	return ret;
}

//-1 = error
int LogicAttack(u_int currentLeg, u_int currentPosition, u_int attackSize, u_int attackChar, int connfd, struct addrinfo *res, u_int userFunc, u_char * userFuncName, void ** Data, u_int * DataSize, u_int printChoice, int * flags, int * UDP_SERV, void * udpaddr)
{
	u_int totalLen, i, k, len;
	int ret=0;
	u_char * Packet;
	///deal with null legs (should that ever happen?)
	if( (len=DataSize[currentLeg]) == 0 ) {
		perror("{{null leg in LogicAttack}}\n");return -1;}
	///process and construct the attack line
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 2, currentPosition, 0, 0, connfd, res);
	Packet=_malloc(len);
	if(attackChar==0x43)
	{
		for(i=0;i<len;i++) { Packet[i]=_rand(256); }
	}
	else
	{
		memcpy(Packet, Data[currentLeg], len);
		if(attackSize<255)
			Packet[currentPosition]=attackSize;
		else
		{
			for(i=_rand(len); i>0; i--)
			{
				k=_rand(len);
				Packet[k]=_rand(256);
			}
		}
	}	
	/// Process, send, and print attack
	totalLen=len;  //done for the sake of isakmp userFunc
	if(userFunc)
		USERFUNC(userFuncName, 0, currentLeg, 3, currentPosition, Packet, totalLen, connfd, res);
	printf("[%d][-l_%x->] ",currentLeg, attackSize);
	_print(totalLen, printChoice, Packet);
		printf("\n");
	//send attack
	if(_write(connfd, Packet, totalLen, flags, UDP_SERV, udpaddr) < 1) {
		ret=1; TIME(); perror("{{{Logic attack write error -- quit and loop}}}"); }
	free(Packet);
	return ret;
}
			
//NULL=error
struct Tok * Build_Fuzzy_Leg(struct Tok * tok, u_int respect, u_int leg, u_int total_toks, int mutation_rate)
{
	struct Tok * fuzzyToks=NULL;
	struct Tok * startTok=NULL;
	struct Tok * currentTok=NULL;
	struct Tok * PktTok=NULL;
	u_int i=0;
	int x=0;

	startTok=tok;
	currentTok=tok;
	//lame error checking
	if( (tok->data == NULL) || (tok->dataLen==0) ){
		perror("{{NULL data or dataLen in Build_Fuzzy_Leg}}\n");return NULL;}
	if( leg < 0){
		perror("{{Bad leg in Build_Fuzzy_Leg}}\n");return NULL;}
	//fuzz either according to respect for current leg or not
	if(respect)
	{
		//Find start of current leg
		while(1)
		{
			if(currentTok->leg == leg)
				break;
			else
				currentTok=currentTok->next;
		}
	}
	else
	{
		//ignore leg and randomly pick a tok to start at
		x=_rand(total_toks);
		for(i=0; i<x; i++)
		{
			currentTok=currentTok->next;
			if(currentTok==NULL)
			{
				currentTok=startTok;
				break;
			}
		}
	}
	//copy each token to a new list and fuzz
	while(1)
	{
		fuzzyToks=Transfer_Tok(currentTok, fuzzyToks);
		//fuzz tok
		if( Fuzz(fuzzyToks, total_toks, mutation_rate) == -1 ) {
			TIME(); fprintf(stderr, "{{Fuzz failed! (returned -1)}}\n"); return NULL;
		}

		//bailout, or not, depending on respect
		if(respect)
		{
			if( (currentTok->next == NULL) || (currentTok->next->leg != leg) )
				break;
			else
				currentTok=currentTok->next;	
		}
		else
		{
			if( (_rand(100)) < 25 )
				break;
			else
			{
				currentTok=currentTok->next;
				if(currentTok==NULL)
					currentTok=startTok;
			}
		}
	}
	//Loop that goes through looking for lens, hashes, etc. and fixes them up
	x=Fix_Lens(fuzzyToks); 
	if( x == -1 ) {
		TIME(); fprintf(stderr, "{{Fix_Lens failed!)}}\n"); return NULL;
	}
	
	//uncomment below lines for debugging purposes only
	//printf("Created this new stream of toks for fuzzing:\n");
	//Print_Toks(fuzzyToks, "all", "short");
	//if ( x > 0)
	//	fprintf(stderr, "\n{{failed to fix the len of %d toks.}}\n", x);
	//fflush(stderr); fflush(stdout);

	//turn fuzzyToks list into Packet with Len (resuing our Tok struct)
	if( (PktTok=Toks_To_Buf(fuzzyToks)) == NULL ) {
		TIME(); fprintf(stderr, "{{Failed to convert from Tok to Buf}}\n"); return NULL;
	}

	//clean up fuzzyToks memory	
	if ( Destroy_Toks(fuzzyToks, "all") == NULL){
		TIME(); perror("{{PktTok Destroy error!}}"); return NULL;}

	return PktTok;
}

//tftp hack returns a new fd a sets us to act like a server for the rest of this leg
//screwy tftp protocol.....
int TftpHack(int * TFTP, int * UDP_SERV, int * SRCPORT)
{
	int newfd=0;
	char * lport=NULL;
	char * lhost="0.0.0.0";
	struct addrinfo hints, *res;
	int err=0;

	*(TFTP)=2;
	*(UDP_SERV)=1;
	lport=_malloc(6);
	memset(lport, 0x00, 6);
	if( *SRCPORT == -1){
		TIME();fprintf(stderr,"{{{ERROR - YOU MUST SET SRCPORT FOR TFTP!}}}\n");return(-1);
	}
	sprintf(lport, "%d", *SRCPORT);
	bzero(&hints, sizeof(hints));
	hints.ai_socktype = SOCK_DGRAM;

	if( (err = getaddrinfo(lhost, lport, &hints, &res)) !=0) {
		TIME();fprintf(stderr,"{{{%s in TftpHack}}}\n",gai_strerror(err));return(-1);}
	if( (newfd = setup_server(res)) == ERROR) {
		TIME();fprintf(stderr, "{{{in TftpHack}}}\n\n");return(-1);}

	return newfd;
}

//This is really, really lame.  I did this so the linking would complete.
//Since some libs/calls aren't need by GPF they weren't getting linked in
//for other calls that did need them.  This is a major cludge.
//The funny thing, I never even call lame() from main, but I guess since this
//lib is loaded in, so are it's dependancies?
lame()
{
 u_char * me, *x, *y;
 u_int8_t a;
 _size8_to_ndata(me, a);
 _ndata_to_size32(me);

 struct Tok * tok; 
 Is_Bracket(tok);
 Is_Numeric(tok);
 Is_Other(tok);
 Is_Quote(tok);
 Is_Special(tok);
 Is_String(tok);
 Is_Ascii(tok);
 _strmov(x, y);
}
