/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

int pattern_mode(int argc, char **argv)
{
	/*Variable Definitions*/
        u_int in, none;
        u_short len;
        int err;
        struct hostent *host_info;      //added for udp
        struct sockaddr_in cliaddr;     //added for udp
        u_char clihost[16];             //added for udp  -- probably won't need except for printing
        u_int i, j, k, l, x, y;
        u_int loops=0;
        int mutation_rate=MED;

        int listenfd, connfd;
        struct addrinfo hints, *res;
        u_int userFunc=1; //0=no user func; 1=yes -- to increasing GPF's speed
        u_int readWait = 3;
        char * captureFilename=NULL;

        u_char *host, *port, *sport;
        u_int delay=100;

	/*Global Variables*/
	u_int  replayMode=0;  //0=client; 1=server
	u_int printChoice=2; //0=ascii; 1=hex; 2=auto
	u_int displayLevel=0; //0=low; 1=med; 2=high
	u_char userFuncName[64];  //holds the name of the userFunc passed from cmdline

	int QuitOnSessionSetupError = 0;
	int flags = 0; //used to store fd flags
	int UDP_SERV=0; //Indicates if we're a UDP server or not; 0=no, 1=yes
	int UDP_SERV_READ=0; //Indicates if we've read once with recvfrom to set udpaddr; 0=no, 1=yes
	int TFTP=0; //for tftp hack 0=no need for it, 1=need it, 2=used it;
	int SRCPORT=-1; //created becuase tftp need to know the srcport.  Now allow user to choose.
	struct sockaddr_in udpaddr;  //added for udp

	//It's a bit ugly have these globals static.
	//Up these if you have a maga huge session to replay
	u_int seq[3000];  //order in which legs took place  0=client speaking; 1=server speaking
	void * Data[1500]; //master list of each of the legs in order
	u_int DataSize[1500];  //used to hold the size of each pkt data
	u_int Count=0;  //total number of client and server legs
	void * readData[1500];  //used to hold a pointer to the data actually read from target
	u_int readDataSize[1500];  //used to hold the size of each pkt read from target
        u_int firstTime = 1;
	ip_address clientIP;
        ip_address serverIP;

	/*prepare the above args into a strange format for the pcap_loop func within, call_readin*/
	void * args[7];
        args[0] = seq;
        args[1] = Data;
        args[2] = DataSize;
        args[3] = &Count;
        args[4] = &firstTime;
        args[5] = &clientIP;
        args[6] = &serverIP;

	/*check number of command line arguments and handle them*/
	if (argc < 17){
		TIME(); fprintf(stderr, "{{{Not enough args}}}\n"); Pattern_GPF_usage(); }
	captureFilename = argv[2];
	/*Call the appropriate readin function*/
	if (strstr(captureFilename, ".gpf") != NULL) //.gpf format
		txt_readin(captureFilename, seq, Data, DataSize, &Count);	
	else { //pcap format
		if ( call_readin(captureFilename, (u_char *) args) !=0) {
			TIME(); fprintf(stderr, "{{{Problem reading in capture file! Are you sure this is a pcap file? If it's a .gpf file be sure it has the .gpf extension.}}}\n\n"); exit(-1); }
	}
	/*reserve spaced for the readData*/
	for(x=0; x<Count; x++)
	{
		readData[x]=_malloc(1500);	
		readDataSize[x]=0;	
	}
	/*handle the rest of the args*/
	//0=act as client; 1=act as server
	if( strcasecmp(argv[3], "client") == 0 )
		replayMode = 0;
	else if ( strcasecmp(argv[3], "server") == 0)
		replayMode = 1;
	else{ TIME(); fprintf(stderr, "{{{Bad replayMode.}}}\n\n"); exit(-1); }
	host = argv[4];
	port = argv[5];
	sport = argv[6];
	if( strcasecmp(sport, "?") == 0 )
		sport = NULL;
	else
		SRCPORT = atoi(sport);
	bzero(&hints, sizeof(hints));
	if ( strcasecmp(argv[7], "UDP") == 0)
		hints.ai_socktype = SOCK_DGRAM;
	else if ( strcasecmp(argv[7], "TCP") == 0 )
		hints.ai_socktype = SOCK_STREAM;
	else
		Pattern_GPF_usage();
	srand( (u_int)(atoi(argv[8])) );
	delay = (u_int)(atoi(argv[9]));
	readWait = (u_int)(atoi(argv[10]));
	if( strcasecmp(argv[11], "ascii") == 0 )
		printChoice = TEXT;
	else if ( strcasecmp(argv[11], "hex") == 0)
		printChoice = HEX;
	else if ( strcasecmp(argv[11], "auto") == 0)
		printChoice = AUTO;
	else{ TIME(); fprintf(stderr, "{{{Bad printChoice.}}}\n\n"); Pattern_GPF_usage(); }
	if( (strcasecmp("none", argv[12]))==0)
		userFunc=0;
	else
		strncpy(userFuncName, argv[12], 60);
	u_char * tokPrint=argv[13];
	u_char * tokAid=argv[14];

	if( (strcasecmp("low",argv[15])) == 0 )
                mutation_rate=LOW;
        else if( (strcasecmp("med", argv[15])) == 0 )
                mutation_rate=MED;
        else if( (strcasecmp("high", argv[15])) == 0 )
                mutation_rate=HIGH;
        else{
                fprintf(stderr, "Bad mutation rate!\r"); exit(-1);}

	if ( strcasecmp(argv[16], "CONTINUE") == 0)
		QuitOnSessionSetupError = 0;
	else if ( strcasecmp(argv[16], "QUIT") == 0 )
		QuitOnSessionSetupError = 1;
	else{ TIME(); fprintf(stderr, "{{{Bad OnSessionSetupError}}}\n\n"); Pattern_GPF_usage(); }
	/*Prepare Networking info*/
	if( (err = getaddrinfo(host, port, &hints, &res)) !=0) {
		TIME(); fprintf(stderr, "{{{%s}}}\n", gai_strerror(err)); exit(-1); }
	/*Bind to server IP for TCP */
	if( replayMode == 1 && hints.ai_socktype == SOCK_STREAM)
	{
		if( (listenfd = setup_server(res)) == ERROR) {
			TIME(); fprintf(stderr, "{{{Setup_server failed}}}\n\n"); exit(-1); }
	}
	//set tftp hack
	if( (replayMode == 0 && atoi(port) == 69) && (hints.ai_socktype == SOCK_DGRAM) )
		TFTP=1;
	/*We're a UDP server*/ //also includes tftp hack
	if( replayMode == 1 || TFTP==1 )
	{
		if(replayMode == 1)
			UDP_SERV=1;
		bzero(&udpaddr, sizeof(udpaddr));
	}
	
	/*Tokenize*/
	struct Tok * Toks=NULL;
	struct Tok * tok=NULL;
	u_int leg=0;
	u_int size=0;
	int total_toks=0;
	u_char * data=NULL;
	printf("\nTokenizing Captured Protocol:\n");
	while(leg<Count)
	{
		if( (replayMode==0 && seq[leg]==0) || (replayMode==1 && seq[leg]==1) )
		{
			data=Data[leg];
			size=DataSize[leg];
			//change this and userFuncs code to dynamic code???
			//tokAids are listed here :: MAKE CHANGES HERE IF YOU ADDED A TOKAID ::
			if( (strcasecmp(tokAid, "GENERIC")) == 0)
				tok=GENERIC(tok, data, size, leg);
			else if( (strcasecmp(tokAid, "NORMAL_ASCII")) == 0)
				tok=NORMAL_ASCII(tok, data, size, leg);
			else if( (strcasecmp(tokAid, "DNS")) == 0)
				tok=DNS(tok, data, size, leg);
			else if( (strcasecmp(tokAid, "ZONE_TRANSFER")) == 0)
				tok=ZONE_TRANSFER(tok, data, size, leg);
			else if( (strcasecmp(tokAid, "AUTO_BINARY")) == 0)
				tok=AUTO_BINARY(tok, data, size, leg);
			else { TIME(); fprintf(stderr, "{{{No such tokAid!}}}\n\n"); exit(-1); }
		}
		leg++;
	}
	Toks=Find_First_Tok(tok);
	Print_Toks(Toks, "all", tokPrint);

	if( (total_toks = Count_Toks(Toks)) == ERROR){
		fprintf(stderr, "{{{NO TOKENS!}}}\n\n"); exit(-1);}
	/*Pattern fuzz*/
	printf("\n%d total legs.\n\n", Count);
	printf("Beginning replay attack:\n");
	while(1)
	{
		//Connect to target if client mode
		if( replayMode == 0)
		{
			if( sport == NULL)
			{
				if( (connfd = setup_client (res)) == ERROR)
				{
					TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n");
					if( QuitOnSessionSetupError )
						exit(-1);
				}
			}
			else
			{
				if( (connfd = setup_client_srcport (res, SRCPORT)) == ERROR)
				{
					TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n");
					if( QuitOnSessionSetupError )
						exit(-1);
				}
			}
		}
		//Accept incoming connections if TCP server mode
		if( replayMode==1 && hints.ai_socktype==SOCK_STREAM)
		{
			if( (connfd = accept(listenfd, (struct sockaddr *)NULL, NULL)) < 0) {
				TIME(); fprintf(stderr, "{{{TCP server setup failed}}}\n\n"); exit(-1); }
		}
		//Bind to server IP for UDP
		if( replayMode == 1 && hints.ai_socktype == SOCK_DGRAM)
		{
			if( (connfd = setup_server(res)) == ERROR) {
				TIME(); fprintf(stderr, "{{{UDP server setup failed}}}\n\n"); exit(-1); }
		}
		//for tftp hack
		if(TFTP ==2)
		{
			TFTP=1;
			UDP_SERV=0;
		}
		//GET fd flags
		FLAG(connfd, &flags);
		//Main fuzzy loop
		leg=0;
		struct Tok * PktTok=NULL;
		//respect
		if( _rand(100) < 94 ) //give respect 94% of the time
		{
			while(leg<Count)
			{
				if( (replayMode==0 && seq[leg]==0) || (replayMode==1 && seq[leg]==1) )
				{
					usleep(delay);	
					P_WRITEAGAIN:
					//Build Fuzzy Leg
					if( (PktTok=Build_Fuzzy_Leg(Toks, RESPECT, leg, total_toks, mutation_rate)) == NULL )
					{
						TIME(); fprintf(stderr, "{{Build_Fuzzy_Leg failed!}}\n"); exit(-1);
					}
					//process attack??
					if(userFunc)
						USERFUNC(userFuncName, 0, leg, 0, 0, PktTok->data, PktTok->dataLen, connfd, res);
					//print attack
					printf("[%d][-p:%d->] ",leg, PktTok->dataLen);
					if(PktTok->dataLen<150)
					{
						_print(PktTok->dataLen, printChoice, PktTok->data);
							printf("\n");
					}
					else
					{
						_print(150, printChoice, PktTok->data);
							printf("...TRUNCATED...\n");
					}
					//send attack
					if(_write(connfd, PktTok->data, PktTok->dataLen, &flags, &UDP_SERV, &udpaddr) < 1)
					{
						TIME(); perror("{{{Pattern attack write error}}}");
					}
					if ( Destroy_Toks(PktTok, "current") == NULL){
						TIME(); perror("{{PktTok Destroy error!}}");}
					leg++;
					//tftp hack
					if(TFTP == 1)
						connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
				}	
				else if( (replayMode==0 && seq[leg]==1) || (replayMode==1 && seq[leg]==0) )
				{
					usleep(delay);	
					P_READAGAIN:
					if( (x=_read(connfd, &flags, &UDP_SERV, &UDP_SERV_READ, &TFTP, Data, readData,
							readDataSize, leg, readWait, &udpaddr, printChoice)) == -2) {
						perror("{{Couldn't Read Socket (R -2)}}"); }
					else if(x == -1) {
						TIME(); perror("{{Dead Socket (R -1)}}"); break; }
					if(userFunc)
					{
						y=USERFUNC(userFuncName, x, leg, 1, 0, readData[leg], readDataSize[leg], connfd, res);
						if( y==-1)
						{
							fprintf(stderr, "{{Didn't like what we got...Let's read again.}}\n");
							goto P_READAGAIN;
						}
						if( y==1)
						{
							fprintf(stderr, "{{Didn't like what we got...Let's write again.}}\n");
							leg--;
							goto P_WRITEAGAIN;
						}
					}
					leg++;
				}
				else
				{
					TIME();fprintf(stderr, "{{{Bad replayMode or seq[]}}}\n");exit(-1);
				}
			}
		}
		//NO respect
		else
		{
			while(leg<Count)
			{
				if( _rand(100) < 65 )
				{
					usleep(delay);	
					P_WRITEAGAIN2:
					//Build Fuzzy Leg
					if( (PktTok=Build_Fuzzy_Leg(Toks, NORESPECT, leg, total_toks, mutation_rate)) == NULL)
					{
						TIME(); fprintf(stderr, "{{Build_Fuzzy_Leg failed!}}\n"); exit(-1);
					}
					//process attack??
					if(userFunc)
						USERFUNC(userFuncName, 0, leg, 0, 0, PktTok->data, PktTok->dataLen, connfd, res);
					//print attack
					printf("[%d][-p:%d->] ",leg, PktTok->dataLen);
					if(PktTok->dataLen<150)
					{
						_print(PktTok->dataLen, printChoice, PktTok->data);
							printf("\n");
					}
					else
					{
						_print(150, printChoice, PktTok->data);
							printf("...TRUNCATED...\n");
					}
					//send attack
					if(_write(connfd, PktTok->data, PktTok->dataLen, &flags, &UDP_SERV, &udpaddr) < 1)
					{
						TIME(); perror("{{{Pattern attack write error}}}");
					}
					if ( Destroy_Toks(PktTok, "current") == NULL){
						TIME(); perror("{{PktTok Destroy error!}}");}
					leg++;
					//tftp hack
					if(TFTP == 1)
						connfd=TftpHack(&TFTP, &UDP_SERV, &SRCPORT);
				}	
				else
				{
					usleep(delay);	
					P_READAGAIN2:
					if( (x=_read(connfd, &flags, &UDP_SERV, &UDP_SERV_READ, &TFTP, Data, readData, readDataSize, leg, readWait, &udpaddr, printChoice)) == -2) {
						perror("{{Couldn't Read Socket (R -2)}}"); }
					else if(x == -1) {
						TIME(); perror("{{Dead Socket (R -1)}}"); break; }
					if(userFunc)
					{
						y=USERFUNC(userFuncName, x, leg, 1, 0, readData[leg], readDataSize[leg], connfd, res);
						if( y==-1)
						{
							fprintf(stderr, "{{Didn't like what we got...Let's read again.}}\n");
							goto P_READAGAIN2;
						}
						if( y==1)
						{
							fprintf(stderr, "{{Didn't like what we got...Let's write again.}}\n");
							leg--;
							goto P_WRITEAGAIN2;
						}
					}
					leg++;
				}
			}
		}
		//loop	
		printf("=================================Total Loops: %d====================================\n\n", loops);
		loops++;
		close(connfd);
		UDP_SERV_READ=0;
	}
	//should never get here
	return(-1);
}
