/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

/*Pure Fuzz*/
int rand_mode(int argc, char ** argv)
{
	/*Variable Definitions*/
        int err;
        u_int in, none;
        u_short len;
        u_char *packet;
        u_int i, j, x, y;

        int connfd;
        struct addrinfo hints, *res;
        u_int readWait = 3;
        u_char *host, *port, *sport;
        u_int delay=100;
	int SRCPORT=-1; //created becuase tftp needs to know the srcport - allow user to choose.

	/*check number of command line arguments*/
	if (argc < 7)
		random_usage();
	/*Handle 2nd and 3rd arg: put into vars*/
	host = argv[3];
	port = argv[4];
	sport = argv[5];
	if( strcasecmp(sport, "?") == 0 )
		sport = NULL;
	else
		SRCPORT = atoi(sport);
	/*Handle 4th arg: perform getaddrinfo() call*/
	bzero(&hints, sizeof(hints));
	if ( strcasecmp(argv[6], "UDP") == 0)
		hints.ai_socktype = SOCK_DGRAM;
	else if ( strcasecmp(argv[6], "TCP") == 0 )
		hints.ai_socktype = SOCK_STREAM;
	else
		random_usage();
	/*Handle 5th arg: Seed random number generator*/	
	srand( (u_int)(atoi(argv[7])) );
	/*Handle 6th arg: Input Delay*/	
	delay = (u_int)(atoi(argv[8]));
	/*Prepare Networking info*/
	if( (err = getaddrinfo(host, port, &hints, &res)) !=0) {
		TIME(); fprintf(stderr, "{{{%s}}}\n", gai_strerror(err)); exit(-1); }
	/*Main code to spew random pkts*/
	j=0;
	in=0;
	calcRange( (u_int *)&none, (u_int *)&x, (u_int *)&y, optarg);
	while(j<=y || none==1)
	{
		if( sport == NULL)
		{
			if( (connfd = setup_client (res)) == ERROR) {
				TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n"); }
		}
		else
		{
			if( (connfd = setup_client_srcport (res, SRCPORT)) == ERROR) {
				TIME(); fprintf (stderr, "{{{Setup_client failed!}}}\n\n"); }
		}
		len=_rand(15000);
		packet=_malloc(len);
		for(i=0;i<len;i++)
		{
			packet[i]=_rand(256);
		}
		if( (j>=x) && (j<=y) || (none == 1) )
		{
			printf("Pkt: %d  len=%6.0d\t", j, len);
			write(connfd, packet, len);
			printf("- sent data\n", j);
			usleep(delay);
		}
		free(packet);
		j++;
		close(connfd);
	}
	printf("\n\n Successful Finish.  Did we crash your target?\n\n");
	exit(0);
}  
