/*  Createright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com
    Createright (c) 2007, VDA Labs, LLC
    Jared DeMott, jdemott@vdalabs.com, www.vdalabs.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "headers.h"

struct Tok * AUTO_BINARY(struct Tok * tok, char * data, int size, u_int leg)
{
	struct ascii * ascii = NULL;
	char * _data = NULL;
	int _size = 0;
	int first_time = 1;
	int ret = OK;

	//error checking
        if( data == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL data passed to AUTO_BINARY tokAid}}}\n"); exit(-1);
        }
        if( (leg < 0) || (leg > 3000) ) {
                TIME(); fprintf(stderr, "{{{Bad leg passed to AUTO_BINARY tokAid}}}\n"); exit(-1);
        }

	//id
	tok=Create_Next_Tok(tok, leg);
	tok->type=SESSION_ID;
	tok->dataLen=2;
	Slurp_Into_Tok(tok, data);
	//flags
	tok=Create_Next_Tok(tok, leg);
	tok->type=FLAGS;
	tok->dataLen=2;
	Slurp_Into_Tok(tok, data);

	/*usually session IDs/flags are at the start of a binary protocol*/


	//this loop will find length feilds that are from HERE to END type LENS

	//this loop will find ascii strings in a data blob
	ascii = _malloc( sizeof(struct ascii) );
	while(1)
	{
		if( first_time )
		{
			_data = data;
			_size = size;
			first_time = 0;
		}
		else
		{
			_data = (ascii->data) + ascii->len;
			_size = (int) ((data + size) - _data);
		}
		if( _size < 1)
		{
			printf("Size decreased to zero.\n");
			break;
		}
		if( (ret=ascii_locator(_data, _size, ascii)) == YES)
		{
			printf("Found an ascii string:\n");
			_print(ascii->size_of_len, HEX, ascii->start_of_len);
			printf(":");
			_print(ascii->len, AUTO, ascii->data);
			printf("\n");

		}
		else if( ret == NO)
		{
			printf("No (more) ascii strings found.\n");
			break;
		}
		else if( ret == ERROR)
		{
			printf("In AUTO_BINARY, ascii_locator returned an error!\n");
			break;
		}
	}
	free(ascii);
	return OK;

	/*Often times we see the proto_id:len:feild:,proto_id:len:field, ... pattern*/ 
	/*Often the len is of size 1 or 2. Often times the feild has ascii data in it.*/


	//roll back to first tok and add extra attributes if there are any
        if ( (tok=Find_First_Tok(tok)) == NULL) {
                        TIME(); fprintf(stderr, "{{{Find_First_Tok error in normal_ascii}}}\n"); exit(-1);
        }
        while(tok->next !=NULL)
        {
		//Is this tok an ascii string (without the null)?
		if( Is_Ascii(tok) )
		{
	                //If so, does the string contain ascii numbers? (0x30-0x39)
	                if(Is_Numeric(tok))
	                        tok->numeric=1;
	                //does it contain bracket?
	                if(Is_Bracket(tok))
	                        tok->bracket=1;
	                //does it contain quote?
	                if(Is_Quote(tok))
	                        tok->quote=1;
	                //does it contain special?
	                if(Is_Special(tok))
	                        tok->special=1;
	                //does it others
	                if(Is_Other(tok))
	                        tok->other=1;
		}

                tok=tok->next;
        }

	
	return tok;
}
