/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "headers.h"

/*tokenization any protocol by leg*/
struct Tok * GENERIC(struct Tok * tok, u_char * data, u_int size, u_int leg)
{

	//error checking
        if( data == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL data passed to generic_ascii tokAid}}}\n"); exit(-1);
        }
        if( (leg < 0) || (leg > 3000) ) {
                TIME(); fprintf(stderr, "{{{Bad leg passed to generic_ascii tokAid}}}\n"); exit(-1);
        }

	tok=Create_Next_Tok(tok, leg);
	tok->type=MIXED;
	tok->dataLen=size;
	Slurp_Into_Tok(tok, data);

	//If so, does the string contain ascii numbers? (0x30-0x39)
	if(Is_Numeric(tok))
		tok->numeric=1;
	//does it contain bracket?
	if(Is_Bracket(tok))
		tok->bracket=1;
	//does it contain quote?
	if(Is_Quote(tok))
		tok->quote=1;
	//does it contain special?
	if(Is_Special(tok))
		tok->special=1;
	//does it contain others
	if(Is_Other(tok))
		tok->other=1;

	return tok;
}
