/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com
    Copyright (c) 2007, VDA Labs, LLC
    Jared DeMott, jdemott@vdalabs.com, www.vdalabs.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

void * _malloc(u_int size)
{
	void * ptr;	
	//error check size
        if( (size < 0) || (size > 99999999) ) {
                TIME(); fprintf(stderr, "{{{Invalid size (%d) passed to _malloc()}}}\n", size); return NULL;
        }

	ptr=malloc(size);	

	//error check ptr
        if( ptr == NULL) {
                TIME(); fprintf(stderr, "{{{NULL ptr returned from malloc()}}}\n"); return NULL;
        }
        
	return ptr;
}

