/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

u_int32_t _ndata_to_size32(u_char * ptr)
{
	//local vars
	u_int32_t num=0;

	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _ndata_to_size32()}}}\n"); return ERROR;
        }

	//to from network data to a host number
	num=ntohl( *((u_int32_t*)ptr) );
        
	return num;
}
u_int16_t _ndata_to_size16(u_char * ptr)
{
	//local vars
	u_int16_t num=0;

	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _ndata_to_size16()}}}\n"); return ERROR;
        }

	//to from network data to a host number
	num=ntohs( *((u_int16_t*)ptr) );
        
	return num;
}
u_int8_t _ndata_to_size8(u_char * ptr)
{
	//local vars
	u_int8_t num=0;

	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _ndata_to_size8()}}}\n"); return ERROR;
        }

	//to from network data to a host number
	num=*((u_int8_t*)ptr);
        
	return num;
}

