/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

int _size32_to_ndata(u_char * ptr, u_int32_t num)
{
	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _size32_to_ndata()}}}\n"); return ERROR;
        }

	//from host to network
	*((u_int32_t *)ptr)=htonl(num);
        
	return 0;
}
int _size16_to_ndata(u_char * ptr, u_int16_t num)
{
	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _size16_to_ndata()}}}\n"); return ERROR;
        }

	//from host to network
	*((u_int16_t *)ptr)=htons(num);
        
	return 0;
}
int _size8_to_ndata(u_char * ptr, u_int8_t num)
{
	//error check size
        if( ptr == NULL ) {
                TIME(); fprintf(stderr, "{{{NULL ptr passed to _size8_to_ndata()}}}\n"); return ERROR;
        }

	//from host to network
	*((u_int8_t *)ptr)=num;
        
	return 0;
}

