/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of GPF.

    GPF is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GPF is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPF; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "headers.h"

/*This is the routine to print a buffer in ASCII or hex
  printChoice=0=ascii; printChoice=1=hex; printChoice=2=auto
  for char: never prints \r;  or \n if on the end of a line*/
int _print(u_int count, u_int printChoice, u_char *buffer)
{
        u_int i;
        u_int guess=0;
        u_int big=0;
        u_int small=0;

	//error checking
	if( (count < 0) || (count > 150000) ) {
                TIME(); fprintf(stderr, "{{{Invalid count passed to _print}}}\n"); return ERROR;
        }
	if( (printChoice < 0) || (printChoice > 2) ) {
                TIME(); fprintf(stderr, "{{{Invalid printChoice passed to _print}}}\n"); return ERROR;
        }
	if( buffer == NULL ) {
                //TIME(); fprintf(stderr, "{{{NULL buffer passed to _print}}}\n"); return ERROR;
		//in the case of valid null buf's lets handle this
		printf("NULL BUF!!");
		fflush(stdout);
		return;
        }
	
                                                                                                                                                             
printf("\"");
        if( printChoice == TEXT)
        {
                for(i=0; i<count; i++)
                {
                        if(buffer[i]==0x0d)
                                printf("\\x0d");
                        else if( (i==(count-1)) && (buffer[i]==0x0a) )
                                printf("\\x0a");
                        else if( (i==(count-1)) && (buffer[i]==0x00) )
                                printf("\\x00");
                        else
                                printf("%c", buffer[i]);
                }
        }
        if( printChoice == HEX)
        {
               	i=0; 
		while(1)
		{
                	printf("%x", (0xff&buffer[i]));
			i++;
			if(i<count)
				printf(" ");
			else
				break;	
		}
        }
        if( printChoice == AUTO)
        {
                if (count > 8)
                {
 			big=1;
                        for(i=0;i<count;i++)
                        {
                                if( (0xff&buffer[i]) > (u_char)0x80)
                                        guess++;
                                if(i==8)
                                        break;
                        }
                }
                else
                {
                        small=1;
                        for(i=0;i<count;i++)
                        {
                                if( ((0xff&buffer[i]) > (u_char)0x80) || ((0xff&buffer[i]) < (u_char)'\t') )
                                        guess++;
                                if(i==8)
                                        break;
                        }
                }
                if( (big==1 && guess>3) || (small==1 && guess>0) )
                {
	               	i=0; 
			while(1)
			{
       			  	printf("%x", (0xff&buffer[i]));
				i++;
				if(i<count)
					printf(" ");
				else
					break;	
			}
                }
                else
                {
                        for(i=0; i<count; i++)
                        {
                                //added this lines for more sane printing during fuzz
                                if(buffer[i]==0x0d)
                                        printf("\\x0d");
                                else if( (i==(count-1)) && (buffer[i]==0x0a) )
                                        printf("\\x0a");
                                else if( (i==(count-1)) && (buffer[i]==0x00) )
                                        printf("\\x00");
                                else if( buffer[i]<=0x08 )
                                        printf(".");
                                else if( (buffer[i]==0x0b) || (buffer[i]==0x0c) )
                                        printf(".");
                                else if( (buffer[i]>=0x0e) && (buffer[i]<=0x1f) )
                                        printf(".");
                                else
                                        printf("%c", buffer[i]);
                        }
                }
 }
printf("\"");
        fflush(stdout);
}
